-------------------------------------
-- Array 3D                        --
-- Copyright by Anders K. Nielsen  --
-- All rights reserved.            --
-- URL: http://www.mcgreed.dk      --
-- Contact: akn@mcgreed.dk         --
-- v 0.83                         --
-------------------------------------
-- TO-DO:
--     

plugin Helper Array3DHelper
name:"Array3D"
classID:#(1084171646, -674168016)
category:"Standard"
extends:dummy
version:1
-- interal version to public: 1: 0.83

(
	parameters mainGeneralSettings rollout:rolloutGeneralSettings
	(
		intUniqueArrayID type:#integer animatable:false default:0
		intArrayType type:#integer animatable:false ui:intArrayType default:1
		strSourceObjectList type:#stringTab animatable:false tabSizeVariable:true
		strArrayPrefixName type:#string animatable:false ui:strArrayPrefixName default:"Array3D_"
		intDuplicateAction type:#integer animatable:false ui:intDuplicateAction default:2
	)
	parameters mainCreation rollout:rolloutObjectCreation
	(
		intAAmount1D type:#integer animatable:false ui:intAAmount1D default:1
		intAAmount2D type:#integer animatable:false ui:intAAmount2D default:1
		intAAmount3D type:#integer animatable:false ui:intAAmount3D default:1
		
		intShowAmount1D type:#integer animatable:false ui:intShowAmount1D default:1
		intShowAmount2D type:#integer animatable:false ui:intShowAmount2D default:1
		intShowAmount3D type:#integer animatable:false ui:intShowAmount3D default:1
		intObjCreation type:#integer animatable:false ui:intObjCreation default:3
		intWireColorFrom type:#integer animatable:false ui:intWireColorFrom default:1
		colWirePalette type:#color animatable:false ui:colWirePalette
		boolFreeze type:#boolean animatable:false ui:boolFreeze checked:false
		boolFrozenAsGrey type:#boolean animatable:false ui:boolFrozenAsGrey checked:false
		boolBoundingBox type:#boolean animatable:false ui:boolBoundingBox checked:false
	)
	parameters mainPosition rollout:rolloutPosition
	(
		boolPositionEnabled type:#boolean animatable:false ui:boolPositionEnabled checked:true

		floatPosition1DX type:#worldUnits animatable:true ui:floatPosition1DX default:0
		floatPosition1DY type:#worldUnits animatable:true ui:floatPosition1DY default:0
		floatPosition1DZ type:#worldUnits animatable:true ui:floatPosition1DZ default:0
		floatPosition2DX type:#worldUnits animatable:true ui:floatPosition2DX default:0
		floatPosition2DY type:#worldUnits animatable:true ui:floatPosition2DY default:0
		floatPosition2DZ type:#worldUnits animatable:true ui:floatPosition2DZ default:0
		floatPosition3DX type:#worldUnits animatable:true ui:floatPosition3DX default:0
		floatPosition3DY type:#worldUnits animatable:true ui:floatPosition3DY default:0
		floatPosition3DZ type:#worldUnits animatable:true ui:floatPosition3DZ default:0
		boolPositionLink1D type:#boolean animatable:false ui:boolPositionLink1D checked:false
		boolPositionLink2D type:#boolean animatable:false ui:boolPositionLink2D checked:false
		boolPositionLink3D type:#boolean animatable:false ui:boolPositionLink3D checked:false
		intSpacingType type:#integer animatable:false ui:intSpacingType default:1
		
		strPos1DSpline type:#string animatable:false default:""
		strPos2DSpline type:#string animatable:false default:""
		strPos3DSpline type:#string animatable:false default:""
		boolActivePos1DSpline type:#boolean animatable:false ui:boolActivePos1DSpline checked:false
		boolActivePos2DSpline type:#boolean animatable:false ui:boolActivePos2DSpline checked:false
		boolActivePos3DSpline type:#boolean animatable:false ui:boolActivePos3DSpline checked:false
		intSplinePosSpread type:#integer animatable:false ui:intSplinePosSpread default:1
	)
	parameters mainRotation rollout:rolloutRotation
	(
		boolRotationEnabled type:#boolean animatable:false ui:boolRotationEnabled checked:false

		floatRotation1DX type:#float animatable:true ui:floatRotation1DX default:0
		floatRotation1DY type:#float animatable:true ui:floatRotation1DY default:0
		floatRotation1DZ type:#float animatable:true ui:floatRotation1DZ default:0
		floatRotation2DX type:#float animatable:true ui:floatRotation2DX default:0
		floatRotation2DY type:#float animatable:true ui:floatRotation2DY default:0
		floatRotation2DZ type:#float animatable:true ui:floatRotation2DZ default:0
		floatRotation3DX type:#float animatable:true ui:floatRotation3DX default:0
		floatRotation3DY type:#float animatable:true ui:floatRotation3DY default:0
		floatRotation3DZ type:#float animatable:true ui:floatRotation3DZ default:0
		boolRotationLink1D type:#boolean animatable:false ui:boolRotationLink1D checked:false
		boolRotationLink2D type:#boolean animatable:false ui:boolRotationLink2D checked:false
		boolRotationLink3D type:#boolean animatable:false ui:boolRotationLink3D checked:false
		intRotationType type:#integer animatable:false ui:intRotationType default:1
		boolRotationObject type:#boolean animatable:false ui:boolRotationObject checked:true
		boolSplineRotation type:#boolean animatable:false ui:boolSplineRotation checked:false
		boolIncrementRotation type:#boolean animatable:false ui:boolIncrementRotation checked:false
	)
	parameters mainScaling rollout:rolloutScaling
	(
		boolScalingEnabled type:#boolean animatable:false ui:boolScalingEnabled checked:false

		floatScaling1DX type:#float animatable:true ui:floatScaling1DX default:0
		floatScaling1DY type:#float animatable:true ui:floatScaling1DY default:0
		floatScaling1DZ type:#float animatable:true ui:floatScaling1DZ default:0
		floatScaling2DX type:#float animatable:true ui:floatScaling2DX default:0
		floatScaling2DY type:#float animatable:true ui:floatScaling2DY default:0
		floatScaling2DZ type:#float animatable:true ui:floatScaling2DZ default:0
		floatScaling3DX type:#float animatable:true ui:floatScaling3DX default:0
		floatScaling3DY type:#float animatable:true ui:floatScaling3DY default:0
		floatScaling3DZ type:#float animatable:true ui:floatScaling3DZ default:0
		boolScalingLink1D type:#boolean animatable:false ui:boolScalingLink1D checked:false
		boolScalingLink2D type:#boolean animatable:false ui:boolScalingLink2D checked:false
		boolScalingLink3D type:#boolean animatable:false ui:boolScalingLink3D checked:false
		intScalingType type:#integer animatable:false ui:intScalingType default:1
	)
	parameters mainLinking rollout:rolloutLinking
	(
		strLinkParent type:#string animatable:false default:""
		intLinkingTo type:#integer animatable:false ui:intLinkingTo default:2
		strLinkCustom type:#string animatable:false default:""
		boolLinkingSplines type:#boolean animatable:false ui:boolLinkingSplines checked:true
	)
	parameters mainOffset rollout:rolloutOffset
	(
		floatOffsetPosX type:#worldUnits animatable:true ui:floatOffsetPosX default:0
		floatOffsetPosY type:#worldUnits animatable:true ui:floatOffsetPosY default:0
		floatOffsetPosZ type:#worldUnits animatable:true ui:floatOffsetPosZ default:0

		floatOffsetRotX type:#float animatable:true ui:floatOffsetRotX default:0
		floatOffsetRotY type:#float animatable:true ui:floatOffsetRotY default:0
		floatOffsetRotZ type:#float animatable:true ui:floatOffsetRotZ default:0
	)
	parameters mainRandomObject rollout:rolloutRandomObject
	(
		intRanObjectSeed type:#integer animatable:true ui:intRanObjectSeed default:1
	)
	parameters mainConvert rollout:rolloutConvert
	(		
		strConvertNewName type:#integer animatable:false ui:strConvertNewName default:3
		strConvertCustom type:#string animatable:false ui:strConvertCustom default:""
		strConvertTo type:#integer animatable:false ui:strConvertTo default:1
		strGroupName type:#string animatable:false ui:strGroupName default:""
	)
	
	--=======================================================================================================
	local rolloutGeneralSettings, rolloutObjectCreation
	local rolloutPosition, rolloutRotation, rolloutScaling
	local rolloutLinking, rolloutOffset, rolloutRandomObject, rolloutConvert
	
	local intPreviousAmount1D = 1, intPreviousAmount2D = 1, intPreviousAmount3D = 1
	local intPreShowAmount1D = 1, intPreShowAmount2D = 1, intPreShowAmount3D = 1
	local intPreviousDupType = 2, strPreviousPrefixName = ""
	local pathDir = (GetDir #scripts) + "\\Array3D\\" -- the script folder path
	local dataRandomArray
	local strPreGroupName
	local strLinkParentOld
	local arrSourceDetails = #()
	local updateArrayObj
	local updateSourceList
	local acceptedCharacters = "1234567890abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ _-."
	--=======================================================================================================
	local helperObj
	on getDisplayMesh do  ( 
        if (helperObj == undefined) do
            helperObj = createInstance pyramid width:10 depth:10 height:10 widthsegs:1 depthSegs:1 heightsegs:1 setRenderable:0
        helperObj.mesh
    )
 
    tool create ( 
        on mousePoint click do (
            viewTM = getCPTM()
            nodeTM = (transMatrix worldPoint) * (inverse viewTM)
            #stop 
        )
    ) 
	--=======================================================================================================
	fn filter_spline o = superclassof o == shape	--filter only shapes
	--=======================================================================================================
	fn validateString whichString =
	( -- Check if the string contains invalid characters
		stringCheck = trimLeft (trimRight whichString) -- remove whitespace in front and back
		if stringCheck.count > 0 then
		( -- if the string isn't empty, continue checking
			for i in stringCheck.count to 1 by -1 do
			(
				if (findString acceptedCharacters (stringCheck[i] as string)) != undefined do
					stringCheck = replace stringCheck i 1 "" -- Remove valid character from stringCheck
			)
			if stringCheck != "" then 
				return stringCheck -- String contains illegal character, return found characters
			else
				return "" -- String is okay, return nothing

		) else (
			return "empty string" -- String was empty (apart from whitespaces)
		)
	)
	--=======================================================================================================
	fn linkObjects whichObjects whichParent =
	(
		if $ != undefined do -- Check if the helper has been created yet
		(
			if  boolLinkingSplines == false then
				splineParent = "undefined" -- Unlink the spline
			else
				splineParent = "$" + whichParent -- Link the spline with selected parent

			if boolActivePos1DSpline == true and getNodeByName (strPos1DSpline) != undefined do
				execute ("$" + strPos1DSpline + ".parent=" + splineParent) 
			if boolActivePos2DSpline == true and getNodeByName (strPos2DSpline) != undefined do
				execute ("$" + strPos2DSpline + ".parent=" + splineParent)
			if boolActivePos3DSpline == true and getNodeByName (strPos3DSpline)!= undefined do
				execute ("$" + strPos3DSpline + ".parent=" + splineParent)

			for i in whichObjects do -- Go though all the selected objects
				execute (i + ".parent=$" + whichParent as string)

			tempOldNode = (getNodeByName(strLinkParentOld as string)) -- Old link object 
			tempNewNode = (getNodeByName(strLinkParent as string)) -- New link object 

			if tempOldNode == undefined do -- if undefined, reset old link object to dummy
			(
				strLinkParentOld = $.name
				tempOldNode = $
			)
			if tempNewNode == undefined do -- if undefined, reset new link object to dummy
			(
				strLinkParent = $.name
				tempNewNode = $
			)

			-- Calculate difference between new and old link parent position and create new offset
			floatOffsetPosX = (tempOldNode.pos[1] + floatOffsetPosX) - tempNewNode.pos[1] -- set new X offset
			floatOffsetPosY = (tempOldNode.pos[2] + floatOffsetPosY) - tempNewNode.pos[2] -- set new Y offset
			floatOffsetPosZ = (tempOldNode.pos[3] + floatOffsetPosZ) - tempNewNode.pos[3] -- set new Z offset
			tempOldNode = tempNewNode = undefined -- release variable
			strLinkParentOld = strLinkParent
		)
	)

	--=======================================================================================================
	fn deleteArrayObj nAction ObjX1 ObjY1 ObjZ1 ObjX2 ObjY2 ObjZ2 =
	(
		with undo off
		(
			disableSceneRedraw()
			-- 1: Delete all array objects, 2: Delete a range of objects							
			if nAction == 1 and $ != undefined then
			(
				-- ================================
				-- BEGIN - Delete all array objects
				if intArrayType == 2  then
				( -- Random Array
					strDeleteChildAll = (strArrayPrefixName as string) + "Ran" + intUniqueArrayID as string + ".arr_*x*x*"
					execute ("delete $'" + strDeleteChildAll as string + "'")
				) else ( -- Group Array
					for i in arrSourceDetails where i[2] != undefined do
					( -- Looping though array and delete each
						strDeleteChildAll = (strArrayPrefixName + i[1]) as string  + ".arr_*x*x*'"
						execute ("delete $'" + strDeleteChildAll as string + "'")
					)
				)
				strDeleteChildAll = undefined -- release variable
				-- END - Delete all array objects
				-- ================================
			) else (
				-- ==============================================
				-- BEGIN - Delete selected range of array objects
				if  intArrayType == 1 then
					loopSourceDetails = arrSourceDetails
				else
					loopSourceDetails = #(#((arrSourceDetails[1][1]),(arrSourceDetails[1][2])))
				for i in loopSourceDetails where i[2] != undefined do
				( -- Start array, first loop though all sources
					if intArrayType == 2  then
					( -- Random Array
						strDeleteChildName = (strArrayPrefixName as string) + "Ran" + intUniqueArrayID as string + ".arr_"
					) else ( -- Group Array
						strDeleteChildName = (strArrayPrefixName + i[1]) as string + ".arr_"
					)
					for z = ObjZ1 to ObjZ2 do
					(
						for y = ObjY1 to ObjY2 do
						(
							for x = ObjX1 to ObjX2 do
							(
								strChildName = strDeleteChildName + (x as string) + "x" + (y as string) + "x" + (z as string)
								strChildObj = getNodeByName (strChildName)
								if strChildObj != undefined do
									delete strChildObj
							)
						)
					)
				)
				strChildName = strDeleteChildName = loopSourceDetails = undefined -- release variable
				-- END - Delete selected range of array objects
				-- ==============================================
			)
			enableSceneRedraw()
			redrawViews()	
		)
	)
	
	fn addArrayObj nAction ObjX1 ObjY1 ObjZ1 ObjX2 ObjY2 ObjZ2 =
	(	-- BEGIN - Update Array
		with undo off
		(
			if $ != undefined do -- Check if the helper has been created yet
			(
				disableSceneRedraw()
				
				intMainSeed = intRanObjectSeed
				seed(intMainSeed)
				
				gradientColor = #(0,0,0)
				
				if  intArrayType == 1 then
					loopSourceDetails = arrSourceDetails
				else
					loopSourceDetails = #(#((arrSourceDetails[1][1]),(arrSourceDetails[1][2])))

				for i in loopSourceDetails where i[2] != undefined do
				( -- Start array, first loop though all sources
					strSourceName = i[1]
					strSourceObj = i[2]
					
					setWireColor = case intWireColorFrom of
					(
						1: strSourceObj.wireColor
						2: colWirePalette -- color set to custom palette
						3: strSourceObj.wireColor
						default: strSourceObj.wireColor
					)

					if intArrayType == 2  then -- Random Array
						strChildName = (strArrayPrefixName as string) + "Ran" + intUniqueArrayID as string + ".arr_"
					else -- Group Array
						strChildName = (strArrayPrefixName + strSourceName) as string + ".arr_"

					
					if intArrayType == 2  then
					( -- Random Array
						tempChildName = (strArrayPrefixName as string) + "Ran" + intUniqueArrayID as string + ".arr_"
						if  intWireColorFrom == 1 and strSourceName != undefined do
							setWireColor = strSourceObj.wirecolor
					) else ( -- Group Array
						tempChildName = (strArrayPrefixName + strSourceName) as string + ".arr_"
					)

					for z = ObjZ1 to ObjZ2 by intShowAmount3D do
					(
						strChildNameZ = "x" + (z as string)
						for y = ObjY1 to ObjY2 by intShowAmount2D do
						(
							strChildNameYZ = "x" + (y as string) + strChildNameZ
							for x = ObjX1 to ObjX2 by intShowAmount1D do
							(
								strChildName = tempChildName + (x as string) + strChildNameYZ
								strChildObj = getNodeByName (strChildName)

								if intWireColorFrom == 3 do -- if 3, the color is going be gradient between x,y,z (red,green,blue)
									setWireColor = (color (gradientColor[1]*x) (gradientColor[2]*y) (gradientColor[3]*z))
								-- if Creation setting is at Create, delete object first
								if intArrayType == 2  then
								( 
									intRandomObjectID = (random 1 (arrSourceDetails.count))
									strSourceName = arrSourceDetails[intRandomObjectID][1] as string
									strSourceObj = arrSourceDetails[intRandomObjectID][2]
								)
								if nAction != 2 and strChildObj == undefined do
								(
									case intDuplicateAction of
									(
										1: strChildObj = copy strSourceObj name:strChildName wirecolor:setWireColor isfrozen:boolFreeze boxmode:boolBoundingBox
										2: strChildObj = instance strSourceObj name:strChildName wirecolor:setWireColor isfrozen:boolFreeze boxmode:boolBoundingBox
										3: strChildObj = reference strSourceObj name:strChildName wirecolor:setWireColor isfrozen:boolFreeze boxmode:boolBoundingBox
										default: strChildObj = instance strSourceObj name:strChildName wirecolor:setWireColor isfrozen:boolFreeze boxmode:boolBoundingBox
									)
								)
							)
						)
					)
				)
				enableSceneRedraw()
				redrawViews()	
				strSourceObj = strSourceName = gradientColor = undefined -- release variables
				loopSourceDetails = strChildName = setWireColor = strChildObj = undefined -- release variables
			)
		)
	)
	--=======================================================================================================
	fn updateArrayObj nAction ObjX1 ObjY1 ObjZ1 ObjX2 ObjY2 ObjZ2 nDubType nWireColor nFreeze nBound nPosition nRotation nScaling =
	(	-- BEGIN - Update Array
		
		with undo off
		(
			if intObjCreation != 4 do -- if 4, skip everything (array disabled)
			(
				if (arrSourceDetails.count != 0 and arrSourceDetails[1][2] != undefined) then
				( -- Since there is sources in the list
					disableSceneRedraw()
					
					tempAmount1D = intAAmount1D - 1
					tempAmount2D = intAAmount2D - 1
					tempAmount3D = intAAmount3D - 1

					-- check if any of the values are invalid
					if ObjX1 == undefined do
						ObjX1 = 1
					if ObjY1 == undefined do
						ObjY1 = 1
					if ObjZ1 == undefined do
						ObjZ1 = 1
					if ObjX2 == undefined do
						ObjX2 = 1
					if ObjY2 == undefined do
						ObjY2 = 1
					if ObjZ2 == undefined do
						ObjZ2 = 1
					
					strSourceName = arrSourceDetails[1][1]
					strSourceObj = arrSourceDetails[1][2]
	
					-- Default wireframe colors
					gradientColor = #(0,0,0)
					
					floatScaleX = [0,0,0]
					floatScaleY = [0,0,0]
					floatScaleZ = [0,0,0]
					local oldSplinePos1, oldSplinePos2, oldSplinePos3
					case intLinkingTo of
					( -- Check if the linking objects exist, if not, assign current object as linking parent
						1: arrDummy = $
						2:(
							if strLinkCustom == "" then
							(
								arrDummy = $ -- Set link to dummy
							) else (
								arrDummy = getNodeByName (strLinkCustom)
								if arrDummy == undefined do 
								(
									strLinkCustom = ""
									arrDummy = $
								)
							)
						)
						default: arrDummy = $
					)

					tempRandom = #()
					tempRandom[29] = 0
					arrayRandomize = #()
					
					intMainSeed = intRanObjectSeed

					-- Get all Array Randomizer Modifiers from the stack
					dataRandomArray = for i in $.modifiers where ((i.classid)[1] == 1164269483 and i.boolRandomizeOn == true) collect i
					for i in dataRandomArray do
					(
						tempRandom = #()
						tempRandom[29] = false -- initilize the array max size
						tempRandom[1] = tempRandom[4] = tempRandom[7] = tempRandom[10] = 0
						tempRandom[13] = tempRandom[16] = tempRandom[19] = tempRandom[22] = tempRandom[25] = 0
						if i.boolRanPosBothX do
							tempRandom[1] = (i.floatRanPosX * -1)/ i.floatRanPosStepX
						
						tempRandom[2] = i.floatRanPosX / i.floatRanPosStepX as float
						tempRandom[3] = i.floatRanPosStepX
						if i.boolRanPosBothY do
							tempRandom[4] = (i.floatRanPosY * -1) / i.floatRanPosStepY as float

						tempRandom[5] = i.floatRanPosY / i.floatRanPosStepY
						tempRandom[6] = i.floatRanPosStepY
						if i.boolRanPosBothZ do
							tempRandom[7] = (i.floatRanPosZ * -1) / i.floatRanPosStepZ as float

						tempRandom[8] = i.floatRanPosZ / i.floatRanPosStepZ
						tempRandom[9] = i.floatRanPosStepZ
						
						if i.boolRanRotBothX do
							tempRandom[10] = (i.floatRanRotX * -1) / i.floatRanRotStepX as float

						tempRandom[11] = i.floatRanRotX / i.floatRanRotStepX
						tempRandom[12] = i.floatRanRotStepX
						if i.boolRanRotBothY do
							tempRandom[13] = (i.floatRanRotY * -1) / i.floatRanRotStepY as float

						tempRandom[14] = i.floatRanRotY / i.floatRanRotStepY
						tempRandom[15] = i.floatRanRotStepY
						if i.boolRanRotBothZ do
							tempRandom[16] = (i.floatRanRotZ * -1) / i.floatRanRotStepZ as float

						tempRandom[17] = i.floatRanRotZ / i.floatRanRotStepZ
						tempRandom[18] = i.floatRanRotStepZ
						
						if i.boolRanScaBothX do
							tempRandom[19] = (i.floatRanScaX * -1) / i.floatRanScaStepX as float

						tempRandom[20] = i.floatRanScaX / i.floatRanScaStepX
						tempRandom[21] = i.floatRanScaStepX
						if i.boolRanScaBothY do
							tempRandom[22] = (i.floatRanScaY * -1) / i.floatRanScaStepY as float

						tempRandom[23] = i.floatRanScaY / i.floatRanScaStepY
						tempRandom[24] = i.floatRanScaStepY
						if i.boolRanScaBothZ do
							tempRandom[25] = (i.floatRanScaZ * -1) / i.floatRanScaStepZ as float

						tempRandom[26] = i.floatRanScaZ / i.floatRanScaStepZ
						tempRandom[27] = i.floatRanScaStepZ
						tempRandom[28] = i.intRanSeed
						tempRandom[29] = i.boolRandomizeOn
						
						arrayRandomize = append arrayRandomize tempRandom
						
						intMainSeed += i.intRanSeed
					)
					-- END - Retrieve randomize data

					seed (intMainSeed) -- Randomize Seed
					if  intArrayType == 1 then -- 1: Group Array, 2: Random Array
						loopSourceDetails = arrSourceDetails
					else
						loopSourceDetails = #(#((arrSourceDetails[1][1]),(arrSourceDetails[1][2])))
					
					floatScalingProc = #(#(0,0,0),#(0,0,0),#(0,0,0))
					floatScalingProc[1][1] = floatScaling1DX/100
					floatScalingProc[1][2] = floatScaling1DY/100
					floatScalingProc[1][3] = floatScaling1DZ/100					

					floatScalingProc[2][1] = floatScaling2DX/100
					floatScalingProc[2][2] = floatScaling2DY/100
					floatScalingProc[2][3] = floatScaling2DZ/100
					
					floatScalingProc[3][1] = floatScaling3DX/100
					floatScalingProc[3][2] = floatScaling3DY/100
					floatScalingProc[3][3] = floatScaling3DZ/100
					
					gradientColor[1] = floor(256 / ObjX2-ObjX1)
					gradientColor[2] = floor(256 / ObjY2-ObjY1)
					gradientColor[3] = floor(256 / ObjZ2-ObjZ1)


					-- BEGIN - Set Spline Variables
					if intSplinePosSpread == 1 then
						setSplineSpread = off -- Spread objects evenly along spline
					else
						setSplineSpread = on -- Spread objects depending on segments on spline

					local oldPos
					local floatSplineTransform1D = #(#())
					local floatSplineTransform2D = #(#()) 
					local floatSplineTransform3D = #(#())

					if (boolActivePos1DSpline == true) do
						strSpline1D = getNodeByName (strPos1DSpline)
					if (boolActivePos2DSpline == true) do
						strSpline2D = getNodeByName (strPos2DSpline)
					if (boolActivePos3DSpline == true) do
						strSpline3D = getNodeByName (strPos3DSpline)

					if boolActivePos1DSpline == true and strSpline1D != undefined and strPos1DSpline != "" then
					( -- Spline 1D is active, get positions on spline
						floatSplineTransform1D[intAAmount1D] = #()
						oldPos =  interpCurve3D strSpline1D 1 0 pathparam:setSplineSpread
						for i = 1 to intAAmount1D do
						(
							floatPerc = i as float / tempAmount1D
							tempPos = interpCurve3D strSpline1D 1 floatPerc pathparam:setSplineSpread
							tempRot = arbAxis (tangentCurve3D strSpline1D 1 floatPerc pathparam:off)

							floatSplineTransform1D[i] = #([(tempPos[1] - oldPos[1]), (tempPos[2] - oldPos[2]), (tempPos[3] - oldPos[3])], tempRot)
							oldPos = tempPos
						)
					)
					if boolActivePos2DSpline == true and strSpline2D != undefined and strPos2DSpline != "" then
					( -- Spline 2D is active, get positions on spline
						floatSplineTransform2D[intAAmount2D] = #()
						oldPos =  interpCurve3D strSpline2D 1 0 pathparam:setSplineSpread
						for i = 1 to intAAmount2D do
						(
							floatPerc = i as float / tempAmount2D
							tempPos = interpCurve3D strSpline2D 1 floatPerc pathparam:setSplineSpread
							tempRot = arbAxis (tangentCurve3D strSpline2D 1 floatPerc pathparam:off)

							floatSplineTransform2D[i] = #([(tempPos[1] - oldPos[1]), (tempPos[2] - oldPos[2]), (tempPos[3] - oldPos[3])], tempRot)
							oldPos = tempPos
						)
					)
					if boolActivePos3DSpline == true and strSpline3D != undefined and strPos3DSpline != "" then
					( -- Spline 3D is active, get positions on spline
						floatSplineTransform3D[intAAmount3D] = #()
						oldPos =  interpCurve3D strSpline3D 1 0 pathparam:setSplineSpread
						for i = 1 to intAAmount3D do
						(
							floatPerc = i as float / tempAmount3D
							tempPos = interpCurve3D strSpline3D 1 floatPerc pathparam:setSplineSpread
							tempRot = arbAxis (tangentCurve3D strSpline3D 1 floatPerc pathparam:off)

							floatSplineTransform3D[i] = #([(tempPos[1] - oldPos[1]), (tempPos[2] - oldPos[2]), (tempPos[3] - oldPos[3])], tempRot)
							oldPos = tempPos
						)
					)
					-- END - Set Spline Variables
					for i in loopSourceDetails where i[2] != undefined do
					( -- Start array, first loop though all sources

						strSourceName = i[1]
						strSourceObj = i[2]

						setWireColor = case intWireColorFrom of
						(
							1: strSourceObj.wireColor -- wirecolor from source objects
							2: colWirePalette -- color set to custom palette
							3: strSourceObj.wireColor -- Gradient wirecolor (temporary from source objects)
							default: strSourceObj.wireColor
						)


						setStartPos = #()
						setStartPos[1] = (floatOffsetPosX + (strSourceObj.pos[1] - arrSourceDetails[1][2].pos[1])) + (arrDummy.pos[1]) as float
						setStartPos[2] = (floatOffsetPosY + (strSourceObj.pos[2] - arrSourceDetails[1][2].pos[2])) + (arrDummy.pos[2]) as float
						setStartPos[3] = (floatOffsetPosZ + (strSourceObj.pos[3] - arrSourceDetails[1][2].pos[3])) + (arrDummy.pos[3]) as float

						sourceTransform = strSourceObj.transform
						sourceTransform.pos = [setStartPos[1], setStartPos[2], setStartPos[3]]

						incrementZ = sourceTransform
						incrementX = (matrix3 incrementZ[1] incrementZ[2] incrementZ[3] incrementZ[4])
						incrementY = (matrix3 incrementZ[1] incrementZ[2] incrementZ[3] incrementZ[4])
						
						if intSpacingType == 1 then
						(
							floatPosition1 = [floatPosition1DX, floatPosition1DY, floatPosition1DZ]
							floatPosition2 = [floatPosition2DX, floatPosition2DY, floatPosition2DZ]
							floatPosition3 = [floatPosition3DX, floatPosition3DY, floatPosition3DZ]
						) else (
							floatPosition1 = [(floatPosition1DX/intAAmount1D), (floatPosition1DY/intAAmount1D), (floatPosition1DZ/intAAmount1D)]
							floatPosition2 = [(floatPosition2DX/intAAmount2D), (floatPosition2DY/intAAmount2D), (floatPosition2DZ/intAAmount2D)]
							floatPosition3 = [(floatPosition3DX/intAAmount3D), (floatPosition3DY/intAAmount3D), (floatPosition3DZ/intAAmount3D)]
						)
						
						-- BEGIN - Calculate and creat objects
						for z = ObjZ1 to ObjZ2 do
						(
							z1 = z - 1
							
							if intRotationType == 1 then -- Decided how much to rotate the objects
								floatRotation3 = [floatRotation3DX, floatRotation3DY, floatRotation3DZ] -- full value for rotation
							else
								floatRotation3 = [(floatRotation3DX/intAAmount3D), (floatRotation3DY/intAAmount3D), (floatRotation3DZ/intAAmount3D)] -- rotation value / amount
							
							-- If active, use spline for Z position
							if boolActivePos3DSpline == true and strSpline3D != undefined and strPos3DSpline != "" do
							( -- Use spline for 3D position
								arrayRotation3D = floatSplineTransform3D[z][2]
								floatPosition3 = floatSplineTransform3D[z][1]
							) 
							
							if boolScalingEnabled == true do -- If true, calculate Z Scaling
							(
								if intScalingType == 1 then
								( -- Scaling using amount per object
									floatScaleZ[1] = (z1*floatScalingProc[3][1]) as float
									floatScaleZ[2] = (z1*floatScalingProc[3][2]) as float
									floatScaleZ[3] = (z1*floatScalingProc[3][3]) as float
								) else ( -- Scaling using total amount / object
									floatScaleZ[1] = (z1*(floatScalingProc[3][1]/intAAmount3D)) as float
									floatScaleZ[2] = (z1*(floatScalingProc[3][2]/intAAmount3D)) as float
									floatScaleZ[3] = (z1*(floatScalingProc[3][3]/intAAmount3D)) as float
								)
							)
							
							for y = ObjY1 to ObjY2 do
							(
								y1 = y - 1
								-- Decided how much to rotate the objects
								if intRotationType == 1 then -- full value for rotation
									floatRotation2 = [floatRotation2DX, floatRotation2DY, floatRotation2DZ]
								else -- rotation value / amount
									floatRotation2 = [(floatRotation2DX/intAAmount2D), (floatRotation2DY/intAAmount2D), (floatRotation2DZ/intAAmount2D)]
									
								if boolActivePos2DSpline == true and strSpline2D != undefined and strPos2DSpline != "" do
								( -- Use spline for 2D position
									arrayRotation2D = floatSplineTransform2D[y][2]
									floatPosition2 = floatSplineTransform2D[y][1]
								)

								-- Calculate Y Scaling
								if boolScalingEnabled == true do -- If true, calculate Y Scaling
								(
									if intScalingType == 1 then
									( -- Scaling using amount per object
										floatScaleY[1] = (y1*floatScalingProc[2][1]) as float
										floatScaleY[2] = (y1*floatScalingProc[2][2]) as float
										floatScaleY[3] = (y1*floatScalingProc[2][3]) as float
									) else ( -- Scaling using total amount / object
										floatScaleY[1] = (y1*(floatScalingProc[2][1]/intAAmount2D)) as float
										floatScaleY[2] = (y1*(floatScalingProc[2][2]/intAAmount2D)) as float
										floatScaleY[3] = (y1*(floatScalingProc[2][3]/intAAmount2D)) as float
									)
								)
								for x = ObjX1  to ObjX2 do
								(
									x1 = x - 1
									-- Decided how much to rotate the objects

									
									-- BEGIN - Get Array Child object
									if intArrayType == 2  then
									( -- Random Array, get random source for array object
										intRandomObjectID = (random 1 (arrSourceDetails.count))
										strSourceName = arrSourceDetails[intRandomObjectID][1] as string
										strSourceObj = arrSourceDetails[intRandomObjectID][2] 
										strChildName = (strArrayPrefixName as string) + "Ran" + intUniqueArrayID as string + ".arr_" + (x as string) + "x" + (y as string) + "x" + (z as string)
										if  intWireColorFrom == 1 and strSourceName != undefined do
											setWireColor = strSourceObj.wirecolor
									) else ( -- Group Array
										strChildName = (strArrayPrefixName + strSourceName) as string + ".arr_" + (x as string) + "x" + (y as string) + "x" + (z as string)
									)
									strChildObj = getNodeByName (strChildName)
									-- END - Get Array Child object

								
									if intRotationType == 1 then
										floatRotation1 = [floatRotation1DX, floatRotation1DY, floatRotation1DZ] -- full value for rotation
									else
										floatRotation1 = [(floatRotation1DX/intAAmount1D), (floatRotation1DY/intAAmount1D), (floatRotation1DZ/intAAmount1D)] -- rotation value / amount
									
									if boolActivePos1DSpline == true and strSpline1D != undefined and strPos1DSpline != "" do
									( -- Use spline for 2D position
										arrayRotation1D = floatSplineTransform1D[x][2]
										floatPosition1 = floatSplineTransform1D[x][1]
									)

									floatScaling = strSourceObj.scale
									-- Calculate scaling
									
									if (nScaling == 1 and boolScalingEnabled == true) do
									(
										if boolScalingEnabled == true do
										(
											if intScalingType == 1 then
											(
												floatScaleX[1] = (x1*floatScalingProc[1][1]) as float
												floatScaleX[2] = (x1*floatScalingProc[1][2]) as float
												floatScaleX[3] = (x1*floatScalingProc[1][3]) as float
											) else (
												floatScaleX[1] = (x1*(floatScalingProc[1][1]/intAAmount1D)) as float
												floatScaleX[2] = (x1*(floatScalingProc[1][2]/intAAmount1D)) as float
												floatScaleX[3] = (x1*(floatScalingProc[1][3]/intAAmount1D)) as float
											)
										)	
										floatScaling[1] += (floatScaleX[1] + floatScaleY[1] + floatScaleZ[1])
										floatScaling[2] += (floatScaleX[2] + floatScaleY[2] + floatScaleZ[2])
										floatScaling[3] += (floatScaleX[3] + floatScaleY[3] + floatScaleZ[3])
									)

									ranPosition = [0,0,0]
									ranRotation = [0,0,0]
									ranScaling =[0,0,0]
									if arrayRandomize.count > 0 do
									(
										for r = 1 to arrayRandomize.count do
										(
											if arrayRandomize[r][29] do
											(
												if boolPositionEnabled == true do
												(
													ranPosition[1] += floor(random arrayRandomize[r][1] arrayRandomize[r][2]) * arrayRandomize[r][3]
													ranPosition[2] += floor(random arrayRandomize[r][4] arrayRandomize[r][5]) * arrayRandomize[r][6]
													ranPosition[3] += floor(random arrayRandomize[r][7] arrayRandomize[r][8]) * arrayRandomize[r][9]
												)

												if boolRotationEnabled == true do
												(
													ranRotation[1] += floor(random arrayRandomize[r][10] arrayRandomize[r][11]) * arrayRandomize[r][12]
													ranRotation[2] += floor(random arrayRandomize[r][13] arrayRandomize[r][14]) * arrayRandomize[r][15]
													ranRotation[3] += floor(random arrayRandomize[r][16] arrayRandomize[r][17]) * arrayRandomize[r][18]
												)
												if boolScalingEnabled == true do
												(
													ranScaling[1] += (((floor(random arrayRandomize[r][19] arrayRandomize[r][20]) * arrayRandomize[r][21])/100)) as float
													ranScaling[2] += (((floor(random arrayRandomize[r][22] arrayRandomize[r][23]) * arrayRandomize[r][24])/100)) as float
													ranScaling[3] += (((floor(random arrayRandomize[r][25] arrayRandomize[r][26]) * arrayRandomize[r][27])/100)) as float
												)
											)
										)
									)
									
									-- If Array Object exist, assign Properties, Position, rotate, scale the array object
									if strChildObj != undefined do
									(
										-- BEGIN - Assign properties to the array object
										if intWireColorFrom == 3 and nAction < 4 do -- if 3, the color is going be gradient between x,y,z (red,green,blue)
											setWireColor = (color (gradientColor[1]*x) (gradientColor[2]*y) (gradientColor[3]*z))
										if nWireColor == 1 do -- Change wireframe color
											strChildObj.wireColor = setWireColor

										if nFreeze == 1 do -- Change the array to freeze/unfreeze
										(
											strChildObj.isFrozen = boolFreeze
											if boolFreeze == true do
												strChildObj.showFrozenInGray = boolFrozenAsGrey
										)
										
										if nBound == 1 do -- Change the array to freeze/unfreeze
											strChildObj.boxMode = boolBoundingBox
										-- END - Assign properties to the array object
										
										
										newTransform = (matrix3 [1,0,0] [0,1,0] [0,0,1] [0,0,0]) -- initilize matrix
										-- Set Rotation on the object
										if boolRotationObject == true then
											newTransform = incrementX
										else
											newTransform = (matrix3 [1,0,0] [0,1,0] [0,0,1] incrementX[4])

										if boolSplineRotation == true do
											if boolActivePos1DSpline == true and strSpline1D != undefined then
												newTransform = (matrix3 floatSplineTransform1D[x][2][1] floatSplineTransform1D[x][2][2] floatSplineTransform1D[x][2][3] incrementX[4])

										if arrayRandomize.count > 0 do
										(
											preRotate newTransform (eulertoquat (eulerAngles ranRotation[1] ranRotation[2] ranRotation[3]))
											preTranslate newTransform ranPosition
										)
										
										strChildObj.transform = newTransform
										
										-- Set Scale on the object
										if boolScalingEnabled == true do
											strChildObj.scale = (floatScaling+[ranScaling[1], ranScaling[2], ranScaling[3]])
									)

									-- ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
									-- END - Reposition the objects
									-- ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

									if boolRotationEnabled == true do
										preRotate incrementX (eulertoquat (eulerAngles floatRotation1[1] floatRotation1[2] floatRotation1[3]))
									if boolPositionEnabled == true do
										if boolIncrementRotation == true then
											preTranslate incrementX  floatPosition1
										else
											in coordsys world translate incrementX  (floatPosition1)
								)
								
								if boolRotationEnabled == true do
									preRotate incrementY (eulertoquat (eulerAngles floatRotation2[1] floatRotation2[2] floatRotation2[3]))
								if boolPositionEnabled == true do
									if boolIncrementRotation == true then
										preTranslate incrementY floatPosition2
									else
										in coordsys world translate incrementY floatPosition2
								incrementX = (matrix3 incrementY[1] incrementY[2] incrementY[3] incrementY[4])
							)
							if boolRotationEnabled == true do
								preRotate incrementZ (eulertoquat (eulerAngles floatRotation3[1] floatRotation3[2] floatRotation3[3]))
							if boolPositionEnabled == true do
								if boolIncrementRotation == true then
									preTranslate incrementZ floatPosition3
								else
									in coordsys world translate incrementZ floatPosition3
							incrementX = (matrix3 incrementZ[1] incrementZ[2] incrementZ[3] incrementZ[4])
							incrementY = (matrix3 incrementZ[1] incrementZ[2] incrementZ[3] incrementZ[4])
						)
					)
					
					if intObjCreation != 2 do
					( -- Start linking the array objects to the dummy (or custom object)
						tempExecuteList = #()
						for i in strSourceObjectList do -- Go though all the selected objects
						(
							if intArrayType == 2 then -- 1: Group objects , 2: Random objects
								tempExecuteList = append tempExecuteList (("$'" + (strArrayPrefixName as string) + "Ran" + intUniqueArrayID as string + ".arr_*x*x*'"))
							else
								tempExecuteList = append tempExecuteList (("$'" + (strArrayPrefixName as string) + i + ".arr_*x*x*'"))
						)
						linkObjects tempExecuteList strLinkParent -- Link all selected objects
						tempExecuteList = undefined -- release the variable
					)
				) else (
					--messageBox "You need to add at least one object to the Selected Sources list.\nUse the Pick or Pick List button to select object(s)." title:"No objects in list" beep:true
				)
				enableSceneRedraw()
				redrawViews()	
			)

		)
		intPreviousAmount1D = intAAmount1D
		intPreviousAmount2D = intAAmount2D
		intPreviousAmount3D = intAAmount3D
		
		-- release variables
		loopSourceDetails = arrayRandomize = tempRandom = gradientColor = dataRandomArray = undefined
		strSourceName = strSourceObj = newTransform = tempExecuteList = undefined
		floatPosition1 = floatPosition2 = floatPosition3 = oldSplinePos1 = oldSplinePos2 = oldSplinePos3 = setStartPos = sourceTransform = undefined
		floatSplineTransform1D = floatSplineTransform2D = floatSplineTransform3D = undefined
		floatRotation1 = floatRotation2 = floatRotation3 = arrayRotation1D = arrayRotation2D = arrayRotation3D = undefined
		floatScaleX = floatScaleY = floatScaleZ = floatScalingProc = undefined
		ranPosition = ranRotation = ranScaling = undefined

	)
	--=======================================================================================================
	fn updateSourceList whichAction whichItem strAug1 =
	(
		if whichAction != undefined and $ != undefined then
		(
			case whichAction of
			(
				"update":
				(
					-- Update source array list
					arrSourceList.items = #()
					for x = 1 to strSourceObjectList.count do
					(
						strSourceName = (strSourceObjectList[x] as string)
						strSourceObj = getNodeByName (strSourceName)
						tempArr = #()
						if strSourceObj == undefined then
						(
							tempArr = append tempArr ("**MISSING** " + strSourceName as string)
							tempArr = append tempArr undefined
						) else (
							tempArr = append tempArr strSourceName
							tempArr = append tempArr strSourceObj
						)
						arrSourceDetails[x] = tempArr
						arrSourceList.items = append arrSourceList.items strSourceName -- Add the source name to the list
					)
					tempArr = undefined -- release variable
				)
				"add":
				(
					-- Add objects to the source list
					checkDup = ""
					for i = 1 to whichItem.count do
					(
						tempObj = whichItem[i]
						tempName = tempObj.name
						if (tempName) == $.name then
						(
							messageBox ("One of the objects is the same as the one that got this modifier assigned to it. Object has been skipped.")
						) else (
							existingItem = findItem strSourceObjectList tempName
							if (existingItem == 0) then
							(
								tempArr = #(tempName,tempObj)
								arrSourceDetails = append arrSourceDetails tempArr
								rolloutGeneralSettings.arrSourceList.items = append rolloutGeneralSettings.arrSourceList.items tempName
								strSourceObjectList = append strSourceObjectList tempName
							) else (
								checkDup += tempName + ", "
							)
						)
					)
					addArrayObj 3 1 1 1 intAAmount1D intAAmount2D intAAmount3D
					updateArrayObj 2 1 1 1 intAAmount1D intAAmount2D intAAmount3D 0 0 0 0 1 0 0
					if checkDup != "" do
						messageBox ("Some object(s) were skipped, as they already existed in the list.\nIf you know they don't exist in the array, the selected objects must be sharing names with other objects in the scene. You need to rename the selected objects before adding them to the modifier. The skipped object(s) are:\n\n" + (substring checkDup 1 ((checkDup.count)-2)))
					tempArr = checkDup = undefined
				)
				"remove":
				(
					-- Remove selected objects from the source list (and scene if needed)
					tempPrefix = strArrayPrefixName
					for i in whichItem.count to 1 by -1 do
					(
						if (strAug1 == true) do -- Delete selected objects
							if (intArrayType == 1) then -- 1: Group objects , 2: Random objects
								tempName = "delete $'" + (tempPrefix as string) + (strSourceObjectList as array)[whichItem[i]] as string + ".arr_*x*x*'"
							else -- delete all random array objects
								tempName = "delete $'" + (tempPrefix as string) + "Ran" + (intUniqueArrayID as string) + ".arr_*x*x*'"
							execute (tempName)

						strSourceObjectList = deleteItem strSourceObjectList (whichItem[i])
						arrSourceDetails = deleteItem arrSourceDetails(whichItem[i])
						rolloutGeneralSettings.arrSourceList.items = deleteItem rolloutGeneralSettings.arrSourceList.items (whichItem[i])
					)
					tempName = undefined
				)
				default:
				(
					print ("Array 3D Error: Missing Action argument in updateSourceList")
				)
			)
		) else (
			print ("Array 3D Error: Missing objects argument in updateSourceList")
		)
	)
	--=======================================================================================================
	rollout rolloutGeneralSettings "General Settings" width:162 height:285
	(
		label lblArrayID "Array ID: **error**" pos:[7,3] width:147 height:15
		GroupBox grpArrayType "Array Type" pos:[4,18] width:154 height:32
		radiobuttons intArrayType "" pos:[12,33] width:139 height:16 labels:#("Group", "Random") columns:2
		edittext strArrayPrefixName "prefix: " pos:[9,195] width:145 height:17
		GroupBox grpSelectedObjects "Selected Sources" pos:[4,51] width:154 height:141
		multiListBox arrSourceList "" pos:[8,66] width:146 height:7
		checkButton btnPickObj "Pick" pos:[11,167] width:40 height:20
		button btnPickList "Pick List" pos:[56,167] width:52 height:20
		button btnRemoveObj "" pos:[133,167] width:20 height:20 images:#((pathDir + "array_icon_deleteicon.png"), (pathDir + "array_icon_deleteicon.png"), 1, 1, 1, 1, 1)
		GroupBox grpDuplicateAction "Duplicate Action" pos:[4,215] width:154 height:41
		dropdownList intDuplicateAction "" pos:[13,231] width:140 height:21 items:#("Copy", "Instance", "Reference") selection:2
		button btnCreateArray "Update All" pos:[9,260] width:70 height:20
		button btnDeleteArray "Delete All" pos:[85,260] width:70 height:20
	
		on intArrayType changed theState do
		(
			if $ != undefined do -- Check if the helper has been created yet
			(
				if queryBox "Are you sure you want to change Array Type?" beep:false then
				(
					if theState == 1 then
					(
						intArrayType.state = 2
						deleteArrayObj 1 1 1 1 1 1 1 -- first delete all objects
						intArrayType.state = 1
						rolloutRandomObject.intRanObjectSeed.enabled = false
						rolloutRandomObject.btnROGenerateSeed.enabled = false
						addArrayObj 3 1 1 1 intAAmount1D intAAmount2D intAAmount3D
						updateArrayObj 1 1 1 1 intAAmount1D intAAmount2D intAAmount3D 1 1 1 1 1 1 1
					) else (
						intArrayType.state = 1
						deleteArrayObj 1 1 1 1 1 1 1 -- first delete all objects
						intArrayType.state = 2
						rolloutRandomObject.intRanObjectSeed.enabled = true
						rolloutRandomObject.btnROGenerateSeed.enabled = true
						addArrayObj 3 1 1 1 intAAmount1D intAAmount2D intAAmount3D
						updateArrayObj 1 1 1 1 intAAmount1D intAAmount2D intAAmount3D 1 1 1 1 1 1 1
					)
				) else (
					if theState == 1 then
						intArrayType.state = 2
					else
						intArrayType.state = 1
				)
			)
		)

		on strArrayPrefixName entered txt beep:false do
		(
			if $ != undefined do -- Check if the helper has been created yet
			(
				-- Validate the text
				stringCheck = validateString strArrayPrefixName.text
				if stringCheck != "" and stringCheck != "empty string" then
				(
					messageBox ("The entered prefix contains illegal characters. Rename cancelled.\n\nOnly these characters is valid for prefix:\n\n1234567890 _-.\nabcdefghijklmnopqrstuvwxyz\nABCDEFGHIJKLMNOPQRSTUVWXYZ\n")
					strArrayPrefixName.text = strPreviousPrefixName
				) else (
					if queryBox "Are you sure you want to change the names\non all the objects?" beep:false then
					(
						disableSceneRedraw()
						with undo off
						(
							for i in arrSourceDetails do
							(
								strSourceName = i[1]
								strSourceObj = i[2]
								for z = 1 to intAAmount3D do
									for y = 1 to intAAmount2D do
										for x = 1  to intAAmount1D do
										(
											if intArrayType == 2 then -- Random objects, use ran ID surfix
												surfix ="Ran" + intUniqueArrayID as string + ".arr_" + x as string + "x" + y as string + "x" + z as string
											else -- Group objects, use object and xyz
												surfix = strSourceName + ".arr_" + x as string + "x" + y as string + "x" + z as string

											strChildName = strPreviousPrefixName + surfix
											strChildObj = getNodeByName (strChildName)
											New_Name = strArrayPrefixName.text as string + surfix
											if strChildObj != undefined do -- Child exist, rename child
												strChildObj.name = New_Name
										)
							)
							New_Name = strChildName = strChildObj = surfix = undefined -- release variable
							strPreviousPrefixName = strArrayPrefixName.text
						)
						enableSceneRedraw()
						redrawViews()	
					) else (
						strArrayPrefixName.text = strPreviousPrefixName
					)
				)
			)
		)

		-- BEGIN - Activate the object picker
		on btnPickObj changed theState do
		(
			if $ != undefined do -- Check if the helper has been created yet
			(
				while ((obj=pickobject message:"Left click on object to add them to the list, right click to stop picking") != undefined and btnPickObj.state == on) do
				(
					if obj.name == $.name then
					(
						messageBox "You cannot pick the object that has the modifier has been assigned to it"
					) else (
						updateSourceList "add" (#(obj)) 0
						updateArrayObj 3 1 1 1 intAAmount1D intAAmount2D intAAmount3D 1 1 1 1 1 1 1
					)
				)
				btnPickObj.state = off
			)
		)
		-- END - Activate the object picker
		
		-- BEGIN - Open objects list for selection
		on btnPickList pressed do
		(
			if $ != undefined do -- Check if the helper has been created yet
			(
				x = selectByName()
				if (x != undefined) do
				(
					updateSourceList "add" (x) 0
					updateArrayObj 3 1 1 1 intAAmount1D intAAmount2D intAAmount3D 1 1 1 1 1 1 1
				)
			)
		)
		-- END - Open objects list for selection
			
		-- BEGIN - Remove objects from list and delete if nessesary
		on btnRemoveObj pressed do
		(
			if $ != undefined do -- Check if the helper has been created yet
			(
				tempList = arrSourceList.selection as array
				if tempList.count > 0 do
				( -- Only run if there is at least one source selected
					tempQuery = queryBox "Are you sure you want to remove selected sources from the list?" beep:false
					if tempQuery do
					(
						tempQuery = queryBox "Do you also want to delete array objects related to selected sources?" beep:false

						updateSourceList "remove" tempList tempQuery
						updateArrayObj 3 1 1 1 intAAmount1D intAAmount2D intAAmount3D 1 1 1 1 1 1 1
					)
				)
				tempList = undefined -- release variable
			)
		)
		-- END - Remove objects from list and delete if nessesary
		
		-- BEGIN - Update and create all array objects if needed
		on btnCreateArray pressed do
		(
			if $ != undefined do -- Check if the helper has been created yet
			(
				--startTime = timeStamp() -- Calculate  performace start time
				if intObjCreation == 1 or intObjCreation == 3 do
				(
					if intObjCreation == 1 do
						deleteArrayObj 1 1 1 1 1 1 1
					addArrayObj 0 1 1 1 intAAmount1D intAAmount2D intAAmount3D
				)
				
				updateArrayObj 2 1 1 1 intAAmount1D intAAmount2D intAAmount3D 1 1 1 1 1 1 1
				--endTime = timeStamp() -- Calculate performace end time
				--format "V0.83, Update All - Start: %    End: %    Diff: %\n\n" startTime endTime (endTime - startTime)  -- Calculate performace time
			)
		)
		-- BEGIN - Update and create all array objects if needed

		-- BEGIN - Delete all array objects
		on btnDeleteArray pressed do -- Click to delete all array objects
			deleteArrayObj 1 1 1 1 1 1 1
		-- END - Delete all array objects
		
		on intDuplicateAction selected theState do
		(
			if queryBox "Are you sure you want to change duplicate type?\nAll objects will be deleted and then updated." beep:false then
			(
				deleteArrayObj 1 1 1 1 1 1 1
				addArrayObj 0 1 1 1 intAAmount1D intAAmount2D intAAmount3D
				updateArrayObj 2 1 1 1 intAAmount1D intAAmount2D intAAmount3D 1 1 1 1 1 1 1
				intPreviousDupType = intDuplicateAction.selection
			) else (
				intDuplicateAction.selection = intPreviousDupType
			)
		)

		on rolloutGeneralSettings open do
		(
			if intUniqueArrayID == 0 do -- If no unique ID, generate a new one.
				intUniqueArrayID = (random 1 99999999)
			lblArrayID.text = "Array ID: #" + intUniqueArrayID as string
			
			intPreviousDupType = intDuplicateAction.selection
			strPreviousPrefixName = strArrayPrefixName.text
			
			-- Populate the Source list
			arrSourceList.items = #()
			checkMissing = 0
			if strSourceObjectList.count > 0 AND getNodeByName (strSourceObjectList[1]) == undefined do
				checkMissing = 1
			for x = 1 to strSourceObjectList.count do
			(
				strChildName = (strSourceObjectList[x] as string)
				strChildObj = getNodeByName (strChildName)
				tempArr = #()
				if strChildObj == undefined then
				(
					tempArr = append tempArr ("**MISSING** " + strChildName as string)
					tempArr = append tempArr undefined
					arrSourceList.items = append arrSourceList.items ("**MISSING** " + strChildName as string)
				) else (
					tempArr = append tempArr strChildName
					tempArr = append tempArr strChildObj
					arrSourceList.items = append arrSourceList.items strChildName
				)
				arrSourceDetails[x] = tempArr
			)
			
			if intObjCreation == 1 do
			(
				deleteArrayObj 1 1 1 1 1 1 1
				addArrayObj 0 1 1 1 intAAmount1D intAAmount2D intAAmount3D
			)
			updateArrayObj 2 1 1 1 intAAmount1D intAAmount2D intAAmount3D 1 1 1 1 1 1 1
			
			if checkMissing == 1 do
				messageBox "The first source object is missing, without it, the array will not update. Either remove it from the list so the next one will be first source, or create an object in the scene with the same name."
		)
	)
	--=======================================================================================================
	rollout rolloutObjectCreation "Object Creation" width:162 height:249
	(
		GroupBox grpAmount "Amount" pos:[4,1] width:154 height:82
		label lblAmount "1D            2D            3D" pos:[19,16] width:129 height:13
		spinner intAAmount1D "" pos:[8,29] width:46 height:16 range:[1,1000,1] type:#integer scale:1
		spinner intAAmount2D "" pos:[57,29] width:46 height:16 range:[1,1000,1] type:#integer scale:1
		spinner intAAmount3D "" pos:[106,29] width:46 height:16 range:[1,1000,1] type:#integer scale:1
		label lblShowAmount "Create every Nth objects:" pos:[15,49] width:129 height:13
		spinner intShowAmount1D "" pos:[8,63] width:46 height:16 range:[1,1000,1] type:#integer scale:1
		spinner intShowAmount2D "" pos:[57,63] width:46 height:16 range:[1,1000,1] type:#integer scale:1
		spinner intShowAmount3D "" pos:[106,63] width:46 height:16 range:[1,1000,1] type:#integer scale:1
		GroupBox grpCreation "Creation" pos:[4,84] width:154 height:46
		radiobuttons intObjCreation "" pos:[9,97] width:180 height:32 labels:#("Create", "Modify", "Modify/Create", "Disable") default:3 columns:2
		GroupBox grpFreezeBB "Freeze/Bounding Box" pos:[4,196] width:154 height:49
		colorPicker colWirePalette "" pos:[118,157] width:27 height:26 
		radiobuttons intWireColorFrom "" pos:[10,145] width:108 height:48 labels:#("From parents", "Select custom --->", "Color gradient") columns:1
		GroupBox grpWireColorCustom "Wireframe Color" pos:[4,131] width:154 height:64
		checkbox boolFreeze "Freeze" pos:[8,211] width:52 height:15
		checkbox boolBoundingBox "Bounding Box" pos:[8,227] width:137 height:15
		checkbox boolFrozenAsGrey "Frozen As Grey" pos:[62,211] width:91 height:15
	
	
		on intAAmount1D changed val do -- change the x amount of objects
		(
			if intPreviousAmount1D < intAAmount1D.value then -- Update the array with the increased amount
				addArrayObj 3 (intPreviousAmount1D+1) 1 1 intAAmount1D.value intAAmount2D.value intAAmount3D.value
			else
				if intPreviousAmount1D > 1 do -- Delete objects if amount is more then 1
					deleteArrayObj 2 (intAAmount1D.value+1) 1 1 intPreviousAmount1D intAAmount2D.value intAAmount3D.value

			intPreviousAmount1D = intAAmount1D.value -- Set previous amount to current
			updateArrayObj 2 1 1 1 intAAmount1D.value intAAmount2D.value intAAmount3D.value 1 1 1 1 1 1 1
		)
		on intAAmount2D changed val do -- change the y amount of objects
		(
			if intPreviousAmount2D < intAAmount2D.value then -- Update the array with the increased amount
				addArrayObj 3 1 (intPreviousAmount2D+1) 1 intAAmount1D.value intAAmount2D.value intAAmount3D.value
			else
				if intPreviousAmount2D > 1 do -- Delete objects if amount is more then 1
					deleteArrayObj 2 1 (intAAmount2D.value+1)  1 intAAmount1D.value intPreviousAmount2D intAAmount3D.value

			intPreviousAmount2D = intAAmount2D.value -- Set previous amount to current
			updateArrayObj 2 1 1 1 intAAmount1D.value intAAmount2D.value intAAmount3D.value 1 1 1 1 1 1 1
		)
		on intAAmount3D changed val do -- change the z amount of objects
		(
			if intPreviousAmount3D < intAAmount3D.value then -- Update the array with the increased amount
				addArrayObj 3 1 1 (intPreviousAmount3D+1) intAAmount1D.value intAAmount2D.value intAAmount3D.value
			else
				if intPreviousAmount3D > 1 do -- Delete objects if amount is more then 1
					deleteArrayObj 2 1 1 (intAAmount3D.value+1)  intAAmount1D.value intAAmount2D.value intPreviousAmount3D
			
			intPreviousAmount3D = intAAmount3D.value -- Set previous amount to current
			updateArrayObj 2 1 1 1 intAAmount1D.value intAAmount2D.value intAAmount3D.value 1 1 1 1 1 1 1
		)
		
		on intShowAmount1D changed val do -- change the x amount of objects
		(
			deleteArrayObj 1 1 1 1 1 1 1
			addArrayObj 3 1 1 1 intAAmount1D.value intAAmount2D.value intAAmount3D.value
			updateArrayObj 3 1 1 1 intAAmount1D.value intAAmount2D.value intAAmount3D.value 1 1 1 1 1 1 1
			intPreShowAmount1D = intShowAmount1D.value -- set new amount to previous amount
		)
		on intShowAmount2D changed val do -- change the y amount of objects
		(
			deleteArrayObj 1 1 1 1 1 1 1
			addArrayObj 3 1 1 1 intAAmount1D.value intAAmount2D.value intAAmount3D.value
			updateArrayObj 3 1 1 1 intAAmount1D.value intAAmount2D.value intAAmount3D.value 1 1 1 1 1 1 1
			intPreShowAmount2D = intShowAmount2D.value -- set new amount to previous amount
		)
		on intShowAmount3D changed val do -- change the z amount of objects
		(
			deleteArrayObj 1 1 1 1 1 1 1
			addArrayObj 3 1 1 1 intAAmount1D.value intAAmount2D.value intAAmount3D.value
			updateArrayObj 3 1 1 1 intAAmount1D.value intAAmount2D.value intAAmount3D.value 1 1 1 1 1 1 1
			intPreShowAmount3D = intShowAmount3D.value -- set new amount to previous amount
		)
		
		on intObjCreation changed theState do -- Change creation type and update the array
			if theState != 4 do 
				updateArrayObj theState 1 1 1 intAAmount1D.value intAAmount2D.value intAAmount3D.value 1 1 1 1 1 1 1
		
		on colWirePalette changed nPaletteColor do -- Change the color of the palette (update if needed)
			if intWireColorFrom.state == 2 do -- if custom color has been selected, update wireframe color
				updateArrayObj 0 1 1 1 intAAmount1D.value intAAmount2D.value intAAmount3D.value 0 1 0 0 0 0 0

		on intWireColorFrom changed theState do -- Change which wireframe color to use
			updateArrayObj 0 1 1 1 intAAmount1D.value intAAmount2D.value intAAmount3D.value 0 1 0 0 0 0 0

		on boolFreeze changed theState do -- Set all array objects freeze/unfreeze
		(
			boolFrozenAsGrey.enabled = theState
			updateArrayObj 0 1 1 1 intAAmount1D.value intAAmount2D.value intAAmount3D.value 0 0 1 0 0 0 0
		)

		on boolFrozenAsGrey changed theState do -- Set all array objects freeze/unfreeze
			updateArrayObj 0 1 1 1 intAAmount1D.value intAAmount2D.value intAAmount3D.value 0 0 1 0 0 0 0
		
		on boolBoundingBox changed theState do -- Set all array objects bounding box on/off
			updateArrayObj 0 1 1 1 intAAmount1D.value intAAmount2D.value intAAmount3D.value 0 0 0 1 0 0 0

		on rolloutObjectCreation open do
		(
			boolFrozenAsGrey.enabled = boolFreeze.state
			intPreviousAmount1D = intAAmount1D.value
			intPreviousAmount2D = intAAmount2D.value
			intPreviousAmount3D = intAAmount3D.value
			intPreShowAmount1D = intShowAmount1D.value
			intPreShowAmount2D = intShowAmount2D.value
			intPreShowAmount3D = intShowAmount3D.value
		)
	)
	--=======================================================================================================
	rollout rolloutPosition "Position" width:162 height:385
	(
		checkbox boolPositionEnabled "Enable Position" pos:[9,4] width:131 height:16
		
		groupBox grpLinearSpacing "Linear Spacing" pos:[4,25] width:154 height:246
		label lblPosition1D "1D" pos:[7,61] width:13 height:15
		spinner floatPosition1DX "X: " pos:[52,42] width:72 height:16 range:[-360,360,0]
		spinner floatPosition1DY "Y: " pos:[52,60] width:72 height:16 range:[-360,360,0]
		spinner floatPosition1DZ "Z: " pos:[52,78] width:72 height:16 range:[-360,360,0]
		checkbox boolPositionLink1D "" pos:[140,54] width:16 height:16
		label lblPosition2D "2D" pos:[7,123] width:13 height:15
		spinner floatPosition2DX "X: " pos:[52,106] width:72 height:16 range:[-360,360,0]
		spinner floatPosition2DY "Y: " pos:[52,124] width:72 height:16 range:[-360,360,0]
		spinner floatPosition2DZ "Z: " pos:[52,142] width:72 height:16 range:[-360,360,0]
		checkbox boolPositionLink2D "" pos:[140,118] width:16 height:16
		label lblPosition3D "3D" pos:[7,188] width:13 height:15
		spinner floatPosition3DX "X: " pos:[52,171] width:72 height:16 range:[-360,360,0]
		spinner floatPosition3DY "Y: " pos:[52,189] width:72 height:16 range:[-360,360,0]
		spinner floatPosition3DZ "Z: " pos:[52,207] width:72 height:16 range:[-360,360,0]
		checkbox boolPositionLink3D "" pos:[140,183] width:16 height:16
		
		ImgTag bmpPosition1D "" pos:[22,47] width:19 height:41 bitmap:(openBitMap (pathDir + "array_icon_bracket.png")) transparent:white
		ImgTag bmpPosition2D "" pos:[22,109] width:19 height:41 bitmap:(openBitMap (pathDir + "array_icon_bracket.png")) transparent:white
		ImgTag bmpPosition3D "" pos:[22,175] width:19 height:41 bitmap:(openBitMap (pathDir + "array_icon_bracket.png")) transparent:white
		ImgTag bmpPositionPadlock1D "" pos:[127,42] width:10 height:41 bitmap:(openBitMap (pathDir + "array_icon_padlock_bracket.png")) transparent:white
		ImgTag bmpPositionPadlock2D "" pos:[127,106] width:10 height:41 bitmap:(openBitMap (pathDir + "array_icon_padlock_bracket.png")) transparent:white
		ImgTag bmpPositionPadlock3D "" pos:[127,170] width:10 height:41 bitmap:(openBitMap (pathDir + "array_icon_padlock_bracket.png")) transparent:white

		dropdownList intSpacingType "Spacing Type:" pos:[9,226] width:146 height:40 items:#("Spacing Per Object", "Spacing Total")
		pickbutton btnPos1DSpline "< pick 1D spline >" pos:[10,289] width:124 height:18 filter:filter_spline
		checkbox boolActivePos1DSpline "" pos:[138,290] width:14 height:14
		pickbutton btnPos2DSpline "< pick 2D spline >" pos:[10,311] width:124 height:18 filter:filter_spline
		checkbox boolActivePos2DSpline "" pos:[138,312] width:14 height:14
		pickbutton btnPos3DSpline "< pick 3D spline >" pos:[10,333] width:124 height:18 filter:filter_spline
		checkbox boolActivePos3DSpline "" pos:[138,334] width:14 height:14
		GroupBox grpSplinePath "Spline Path" pos:[4,272] width:154 height:109
		dropdownList intSplinePosSpread "" pos:[9,355] width:144 height:21 items:#("Spread Evenly","Per Segment")
	
		on boolPositionEnabled changed theState do
		(
			theState = boolPositionEnabled.state
			if boolPositionEnabled.state then
			(
				floatPosition1DY.enabled = floatPosition1DZ.enabled = not boolPositionLink1D.state
				floatPosition2DY.enabled = floatPosition2DZ.enabled = not boolPositionLink2D.state
				floatPosition3DY.enabled = floatPosition3DZ.enabled = not boolPositionLink3D.state
			) else (
				floatPosition1DY.enabled = floatPosition1DZ.enabled = floatPosition2DY.enabled = false
				floatPosition2DZ.enabled = floatPosition3DY.enabled = floatPosition3DZ.enabled = false
			)
			floatPosition1DX.enabled = floatPosition2DX.enabled = floatPosition3DX.enabled = theState
			boolPositionLink1D.enabled = boolPositionLink2D.enabled = boolPositionLink3D.enabled = theState
			intSpacingType.enabled = theState

			updateArrayObj 2 1 1 1 intAAmount1D intAAmount2D intAAmount3D 0 0 0 0 1 0 0
		)

		on boolPositionLink1D changed theState do
		(
			floatPosition1DY.enabled = floatPosition1DZ.enabled = not theState
			floatPosition1DY.value = floatPosition1DZ.value = floatPosition1DX.value
			updateArrayObj 2 1 1 1 intAAmount1D intAAmount2D intAAmount3D 0 0 0 0 1 0 0
		)
		on boolPositionLink2D changed theState do
		(
			floatPosition2DY.enabled = floatPosition2DZ.enabled = not theState
			floatPosition2DY.value = floatPosition2DZ.value = floatPosition2DX.value
			updateArrayObj 2 1 1 1 intAAmount1D intAAmount2D intAAmount3D 0 0 0 0 1 0 0
		)
		on boolPositionLink3D changed theState do
		(
			floatPosition3DY.enabled = floatPosition3DZ.enabled = not theState
			floatPosition3DY.value = floatPosition3DZ.value  = floatPosition3DX.value
			updateArrayObj 2 1 1 1 intAAmount1D intAAmount2D intAAmount3D 0 0 0 0 1 0 0
		)

		on floatPosition1DX changed val do
		(
			if boolPositionLink1D.state do
				floatPosition1DY.value = floatPosition1DZ.value = floatPosition1DX.value
			updateArrayObj 2 1 1 1 intAAmount1D intAAmount2D intAAmount3D 0 0 0 0 1 0 0
		)
		on floatPosition2DX changed val do
		(
			if boolPositionLink2D.state do
				floatPosition2DZ.value = floatPosition2DY.value = floatPosition2DX.value
			updateArrayObj 2 1 1 1 intAAmount1D intAAmount2D intAAmount3D 0 0 0 0 1 0 0
		)
		on floatPosition3DX changed val do
		(
			if boolPositionLink3D.state do
				floatPosition3DZ.value = floatPosition3DY.value = floatPosition3DX.value
			updateArrayObj 2 1 1 1 intAAmount1D intAAmount2D intAAmount3D 0 0 0 0 1 0 0
		)
		on floatPosition1DY changed val do updateArrayObj 2 1 1 1 intAAmount1D intAAmount2D intAAmount3D 0 0 0 0 1 0 0
		on floatPosition1DZ changed val do updateArrayObj 2 1 1 1 intAAmount1D intAAmount2D intAAmount3D 0 0 0 0 1 0 0
		on floatPosition2DY changed val do updateArrayObj 2 1 1 1 intAAmount1D intAAmount2D intAAmount3D 0 0 0 0 1 0 0
		on floatPosition2DZ changed val do updateArrayObj 2 1 1 1 intAAmount1D intAAmount2D intAAmount3D 0 0 0 0 1 0 0
		on floatPosition3DY changed val do updateArrayObj 2 1 1 1 intAAmount1D intAAmount2D intAAmount3D 0 0 0 0 1 0 0
		on floatPosition3DZ changed val do updateArrayObj 2 1 1 1 intAAmount1D intAAmount2D intAAmount3D 0 0 0 0 1 0 0
		
		on intSpacingType selected theState do
			updateArrayObj 2 1 1 1 intAAmount1D intAAmount2D intAAmount3D 0 0 0 0 1 0 0
		
		on btnPos1DSpline picked obj do
		(
			if obj != undefined do -- if newly selected spline is valid, continue
			(
				tempSplineObj = getNodeByName (strPos1DSpline) -- Old Spline
				if tempSplineObj != undefined and strPos1DSpline != strPos2DSpline and strPos1DSpline != strPos3DSpline do -- if old spline isn't used in any other, unlink it from dummy
					tempSplineObj.parent = undefined
				tempParent = (getNodeByName(strLinkParent))

				if boolLinkingSplines == true do
				( -- if true, link the spline to dummy or custom object
					if (getNodeByName(strLinkParent))  == undefined do -- if undefined, reset old link object to dummy if needed
					(
						strLinkParent = $.name
						tempParent = $
					)
					obj.parent = tempParent
				)
				strPos1DSpline = obj.name
				btnPos1DSpline.text = "1D: " + obj.name as string
			)
			updateArrayObj 2 1 1 1 intAAmount1D intAAmount2D intAAmount3D 0 0 0 0 1 1 1
		)			
		on btnPos2DSpline picked obj do
		(
			if obj != undefined do
			(
				tempSplineObj = getNodeByName (strPos2DSpline) -- Old Spline
				if tempSplineObj != undefined and strPos2DSpline != strPos1DSpline and strPos2DSpline != strPos3DSpline do -- if old spline isn't used in any other, unlink it from dummy
					tempSplineObj.parent = undefined
				tempParent = (getNodeByName(strLinkParent))

				if boolLinkingSplines == true do
				( -- if true, link the spline to dummy or custom object
					if (getNodeByName(strLinkParent))  == undefined do -- if undefined, reset old link object to dummy if needed
					(
						strLinkParent = $.name
						tempParent = $
					)
					obj.parent = tempParent
				)
				strPos2DSpline = obj.name
				btnPos2DSpline.text = "2D: " + obj.name as string
			)
			updateArrayObj 2 1 1 1 intAAmount1D intAAmount2D intAAmount3D 0 0 0 0 1 1 1
		)
		on btnPos3DSpline picked obj do
		(
			if obj != undefined do
			(
				tempSplineObj = getNodeByName (strPos3DSpline) -- Old Spline
				if tempSplineObj != undefined and strPos3DSpline != strPos2DSpline and strPos3DSpline != strPos1DSpline do -- if old spline isn't used in any other, unlink it from dummy
					tempSplineObj.parent = undefined
				tempParent = (getNodeByName(strLinkParent))

				if boolLinkingSplines == true do
				( -- if true, link the spline to dummy or custom object
					if (getNodeByName(strLinkParent))  == undefined do -- if undefined, reset old link object to dummy if needed
					(
						strLinkParent = $.name
						tempParent = $
					)
					obj.parent = tempParent
				)
				strPos3DSpline = obj.name
				btnPos3DSpline.text = "1D: " + obj.name as string
			)
			updateArrayObj 2 1 1 1 intAAmount1D intAAmount2D intAAmount3D 0 0 0 0 1 1 1
		)
		on boolActivePos1DSpline changed theState do
		(
			btnPos1DSpline.enabled = theState
			if boolActivePos1DSpline.state == true and boolActivePos2DSpline.state == true and boolActivePos3DSpline.state == true then
				intSplinePosSpread.enabled = false
			else
				intSplinePosSpread.enabled = true
			if theState == true then
			(
				floatPosition1DY.enabled = floatPosition1DZ.enabled = not theState
				floatPosition1DX.enabled = boolPositionLink1D.enabled = not theState
			) else (
				floatPosition1DY.enabled = floatPosition1DZ.enabled =  not boolPositionLink1D.state
				if boolPositionLink1D.state then
					floatPosition1DX.enabled = boolPositionLink1D.enabled = boolPositionLink1D.state
				else
					floatPosition1DX.enabled = boolPositionLink1D.enabled = not theState
			)

			updateArrayObj 2 1 1 1 intAAmount1D intAAmount2D intAAmount3D 0 0 0 0 1 1 1
		)
		on boolActivePos2DSpline changed theState do
		(
			btnPos2DSpline.enabled = theState
			if boolActivePos2DSpline.state == true and boolActivePos2DSpline.state == true and boolActivePos3DSpline.state == true then
				intSplinePosSpread.enabled = false
			else
				intSplinePosSpread.enabled = true
			if theState == true then
			(
				floatPosition2DY.enabled = floatPosition2DZ.enabled = not theState
				floatPosition2DX.enabled = boolPositionLink2D.enabled = not theState
			) else (
				floatPosition2DY.enabled = floatPosition2DZ.enabled =  not boolPositionLink2D.state
				if boolPositionLink2D.state then
					floatPosition2DX.enabled = boolPositionLink2D.enabled = boolPositionLink2D.state
				else
					floatPosition2DX.enabled = boolPositionLink2D.enabled = not theState
			)
			updateArrayObj 2 1 1 1 intAAmount1D intAAmount2D intAAmount3D 0 0 0 0 1 1 1
		)
		on boolActivePos3DSpline changed theState do
		(
			btnPos3DSpline.enabled = theState
			if boolActivePos3DSpline.state == true and boolActivePos2DSpline.state == true and boolActivePos3DSpline.state == true then
				intSplinePosSpread.enabled = false
			else
				intSplinePosSpread.enabled = true
			if theState == true then
			(
				floatPosition3DY.enabled = floatPosition3DZ.enabled = not theState
				floatPosition3DX.enabled = boolPositionLink3D.enabled = not theState
			) else (
				floatPosition3DY.enabled = floatPosition3DZ.enabled =  not boolPositionLink3D.state
				if boolPositionLink3D.state then
					floatPosition3DX.enabled = boolPositionLink3D.enabled = boolPositionLink3D.state
				else
					floatPosition3DX.enabled = boolPositionLink3D.enabled = not theState
			)
			updateArrayObj 2 1 1 1 intAAmount1D intAAmount2D intAAmount3D 0 0 0 0 1 1 1
		)
		on intSplinePosSpread selected theState do
			updateArrayObj 2 1 1 1 intAAmount1D intAAmount2D intAAmount3D 0 0 0 0 1 0 0
		
		on rolloutPosition open do
		(
			theState = boolPositionEnabled.state

			if boolPositionEnabled.state then
			(
				floatPosition1DY.enabled = floatPosition1DZ.enabled = not boolPositionLink1D.state
				floatPosition2DY.enabled = floatPosition2DZ.enabled = not boolPositionLink2D.state
				floatPosition3DY.enabled = floatPosition3DZ.enabled = not boolPositionLink3D.state
			) else (
				floatPosition1DY.enabled = floatPosition1DZ.enabled = floatPosition2DY.enabled = false
				floatPosition2DZ.enabled = floatPosition3DY.enabled = floatPosition3DZ.enabled = false
			)
			floatPosition1DX.enabled = floatPosition2DX.enabled = floatPosition3DX.enabled = theState
			boolPositionLink1D.enabled = boolPositionLink2D.enabled = boolPositionLink3D.enabled = theState
			intSpacingType.enabled = theState
			
			btnPos1DSpline.enabled = boolActivePos1DSpline.checked
			btnPos2DSpline.enabled = boolActivePos2DSpline.checked
			btnPos3DSpline.enabled = boolActivePos3DSpline.checked

			if strPos1DSpline != "" then
				btnPos1DSpline.text = "1D: " + strPos1DSpline as string
			else
				btnPos1DSpline.text = "< Pos 1D spline >"

			if strPos2DSpline != "" then
				btnPos2DSpline.text = "2D: " + strPos2DSpline as string
			else
				btnPos2DSpline.text = "< Pos 2D spline >"

			if strPos3DSpline != "" then
				btnPos3DSpline.text = "3D: " + strPos3DSpline as string
			else
				btnPos3DSpline.text = "< Pos 3D spline >"

			if boolActivePos1DSpline.state == true and boolActivePos2DSpline.state == true and boolActivePos3DSpline.state == true then
				intSplinePosSpread.enabled = false
			else
				intSplinePosSpread.enabled = true

			btnPos1DSpline.enabled = theState = boolActivePos1DSpline.state
			if theState then
				floatPosition1DY.enabled = floatPosition1DZ.enabled = not theState
			else
				floatPosition1DY.enabled = floatPosition1DZ.enabled = not boolPositionLink1D.state

			floatPosition1DX.enabled = boolPositionLink1D.enabled = not theState

			btnPos2DSpline.enabled = theState = boolActivePos2DSpline.state
			if theState then
				floatPosition2DY.enabled = floatPosition2DZ.enabled = not theState
			else
				floatPosition2DY.enabled = floatPosition2DZ.enabled = not boolPositionLink2D.state

			floatPosition2DX.enabled = boolPositionLink2D.enabled = not theState
		
			btnPos3DSpline.enabled = theState = boolActivePos3DSpline.state
			if theState then
				floatPosition3DY.enabled = floatPosition3DZ.enabled = not theState
			else
				floatPosition3DY.enabled = floatPosition3DZ.enabled = not boolPositionLink3D.state

			floatPosition3DX.enabled = boolPositionLink3D.enabled = not theState
		)
	)
	--=======================================================================================================
	rollout rolloutRotation "Rotation" width:162 height:311
	(
		checkbox boolRotationEnabled "Enable Rotation?" pos:[9,4] width:131 height:16

		label lblRotation1D "1D" pos:[2,48] width:13 height:15
		spinner floatRotation1DX "X: " pos:[47,28] width:80 height:16 range:[-360,360,0]
		spinner floatRotation1DY "Y: " pos:[47,48] width:80 height:16 range:[-360,360,0]
		spinner floatRotation1DZ "Z: " pos:[47,68] width:80 height:16 range:[-360,360,0]
		checkbox boolRotationLink1D "" pos:[145,48] width:16 height:16

		label lblRotation2D "2D" pos:[2,118] width:13 height:15
		spinner floatRotation2DX "X: " pos:[47,98] width:80 height:16 range:[-360,360,0]
		spinner floatRotation2DY "Y: " pos:[47,118] width:80 height:16 range:[-360,360,0]
		spinner floatRotation2DZ "Z: " pos:[47,138] width:80 height:16 range:[-360,360,0]
		checkbox boolRotationLink2D "" pos:[145,118] width:16 height:16

		label lblRotation3D "3D" pos:[2,189] width:13 height:15
		spinner floatRotation3DX "X: " pos:[47,169] width:80 height:16 range:[-360,360,0]
		spinner floatRotation3DY "Y: " pos:[47,189] width:80 height:16 range:[-360,360,0]
		spinner floatRotation3DZ "Z: " pos:[47,209] width:80 height:16 range:[-360,360,0]
		checkbox boolRotationLink3D "" pos:[145,189] width:16 height:16

		ImgTag bmpRotation1D "" pos:[17,34] width:19 height:41 bitmap:(openBitMap (pathDir + "array_icon_bracket.png")) transparent:white
		ImgTag bmpRotation2D "" pos:[17,104] width:19 height:41 bitmap:(openBitMap (pathDir + "array_icon_bracket.png")) transparent:white
		ImgTag bmpRotation3D "" pos:[17,174] width:19 height:41 bitmap:(openBitMap (pathDir + "array_icon_bracket.png")) transparent:white
		ImgTag bmpRotationPadlock1D "" pos:[130,36] width:10 height:41 bitmap:(openBitMap (pathDir + "array_icon_padlock_bracket.png")) transparent:white
		ImgTag bmpRotationPadlock2D "" pos:[130,106] width:10 height:41 bitmap:(openBitMap (pathDir + "array_icon_padlock_bracket.png")) transparent:white
		ImgTag bmpRotationPadlock3D "" pos:[130,176] width:10 height:41 bitmap:(openBitMap (pathDir + "array_icon_padlock_bracket.png")) transparent:white

		dropdownList intRotationType "Rotation Type:" pos:[10,230] width:146 height:40 items:#("Rotation Per Object", "Rotation Total")
		checkbox boolRotationObject "Rotate By Object" pos:[9,274] width:118 height:18
		checkbox boolSplineRotation "Rotate By Spline" pos:[9,291] width:118 height:18
		checkbox boolIncrementRotation "Increment Rotation" pos:[9,308] width:118 height:18

		on boolRotationEnabled changed theState do
		(
			if theState then
			(
				floatRotation1DY.enabled = floatRotation1DZ.enabled = not boolRotationLink1D.state
				floatRotation2DY.enabled = floatRotation2DZ.enabled = not boolRotationLink2D.state
				floatRotation3DY.enabled = floatRotation3DZ.enabled = not boolRotationLink3D.state
				floatRotation1DX.enabled = floatRotation2DX.enabled = floatRotation3DX.enabled = theState
				boolSplineRotation.enabled = theState
				boolIncrementRotation.enabled = boolRotationObject.enabled = not boolSplineRotation.state
			) else (
				floatRotation1DY.enabled = floatRotation1DZ.enabled = floatRotation2DY.enabled = false
				floatRotation2DZ.enabled = floatRotation3DY.enabled = floatRotation3DZ.enabled = false
				floatRotation1DX.enabled = floatRotation2DX.enabled = floatRotation3DX.enabled = false
				boolIncrementRotation.enabled = boolSplineRotation.enabled = boolRotationObject.enabled = false
			)

			boolRotationLink1D.enabled = boolRotationLink2D.enabled = boolRotationLink3D.enabled = theState
			intRotationType.enabled = theState

			updateArrayObj 2 1 1 1 intAAmount1D intAAmount2D intAAmount3D 0 0 0 0 0 1 0
		)
		on boolRotationLink1D changed theState do
		(
			floatRotation1DY.enabled = floatRotation1DZ.enabled = not theState
			floatRotation1DY.value = floatRotation1DZ.value = floatRotation1DX.value
			updateArrayObj 2 1 1 1 intAAmount1D intAAmount2D intAAmount3D 0 0 0 0 0 1 0
		)
		on boolRotationLink2D changed theState do
		(
			floatRotation2DY.enabled = floatRotation2DZ.enabled = not theState
			floatRotation2DY.value = floatRotation2DZ.value = floatRotation2DX.value
			updateArrayObj 2 1 1 1 intAAmount1D intAAmount2D intAAmount3D 0 0 0 0 0 1 0
		)
		on boolRotationLink3D changed theState do
		(
			floatRotation3DY.enabled = floatRotation3DZ.enabled = not theState
			floatRotation3DY.value = floatRotation3DZ.value  = floatRotation3DX.value
			updateArrayObj 2 1 1 1 intAAmount1D intAAmount2D intAAmount3D 0 0 0 0 0 1 0
		)

		on floatRotation1DX changed val do
		(
			if boolRotationLink1D.state == true do
				floatRotation1DY.value = floatRotation1DZ.value = floatRotation1DX.value
			updateArrayObj 2 1 1 1 intAAmount1D intAAmount2D intAAmount3D 0 0 0 0 0 1 0
		)
		on floatRotation2DX changed val do
		(
			if boolRotationLink2D.state == true do
				floatRotation2DZ.value = floatRotation2DY.value = floatRotation2DX.value
			updateArrayObj 2 1 1 1 intAAmount1D intAAmount2D intAAmount3D 0 0 0 0 0 1 0
		)
		on floatRotation3DX changed val do
		(
			if boolRotationLink3D.state == true do
				floatRotation3DZ.value = floatRotation3DY.value = floatRotation3DX.value
			updateArrayObj 2 1 1 1 intAAmount1D intAAmount2D intAAmount3D 0 0 0 0 0 1 0
		)
		
		on floatRotation1DY changed val do
			updateArrayObj 2 1 1 1 intAAmount1D intAAmount2D intAAmount3D 0 0 0 0 0 1 0
		on floatRotation1DZ changed val do
			updateArrayObj 2 1 1 1 intAAmount1D intAAmount2D intAAmount3D 0 0 0 0 0 1 0
		on floatRotation2DY changed val do
			updateArrayObj 2 1 1 1 intAAmount1D intAAmount2D intAAmount3D 0 0 0 0 0 1 0
		on floatRotation2DZ changed val do
			updateArrayObj 2 1 1 1 intAAmount1D intAAmount2D intAAmount3D 0 0 0 0 0 1 0
		on floatRotation3DY changed val do
			updateArrayObj 2 1 1 1 intAAmount1D intAAmount2D intAAmount3D 0 0 0 0 0 1 0
		on floatRotation3DZ changed val do
			updateArrayObj 2 1 1 1 intAAmount1D intAAmount2D intAAmount3D 0 0 0 0 0 1 0

		on intRotationType selected theState do
			updateArrayObj 2 1 1 1 intAAmount1D intAAmount2D intAAmount3D 0 0 0 0 0 1 0
		
		on boolRotationObject changed theState do
			updateArrayObj 2 1 1 1 intAAmount1D intAAmount2D intAAmount3D 0 0 0 0 1 1 1
		on boolSplineRotation changed theState do
		(
			boolRotationObject.enabled = not theState
			boolIncrementRotation.enabled = not theState
			updateArrayObj 2 1 1 1 intAAmount1D intAAmount2D intAAmount3D 0 0 0 0 1 1 1
		)
		on boolIncrementRotation changed theState do
			updateArrayObj 2 1 1 1 intAAmount1D intAAmount2D intAAmount3D 0 0 0 0 1 1 1
		
		on rolloutRotation open do
		(
			theState = boolRotationEnabled.state
			if theState then
			(
				floatRotation1DY.enabled = floatRotation1DZ.enabled = not boolRotationLink1D.state
				floatRotation2DY.enabled = floatRotation2DZ.enabled = not boolRotationLink2D.state
				floatRotation3DY.enabled = floatRotation3DZ.enabled = not boolRotationLink3D.state
				floatRotation1DX.enabled = floatRotation2DX.enabled = floatRotation3DX.enabled = theState

				boolIncrementRotation.enabled = boolRotationObject.enabled = not boolSplineRotation.state
			) else (
				floatRotation1DY.enabled = floatRotation1DZ.enabled = floatRotation2DY.enabled = false
				floatRotation2DZ.enabled = floatRotation3DY.enabled = floatRotation3DZ.enabled = false
				floatRotation1DX.enabled = floatRotation2DX.enabled = floatRotation3DX.enabled = false
				boolIncrementRotation.enabled = boolSplineRotation.enabled = boolRotationObject.enabled = false
			)

			boolRotationLink1D.enabled = boolRotationLink2D.enabled = boolRotationLink3D.enabled = theState
			intRotationType.enabled = theState

		)
	)
	--=======================================================================================================
	rollout rolloutScaling "Scaling" width:162 height:257 rolledUp:true 
	(
		checkbox boolScalingEnabled "Enable Scaling" pos:[9,4] width:131 height:16

		label lblScaling1D "1D" pos:[2,48] width:13 height:15
		spinner floatScaling1DX "X: " pos:[47,28] width:80 height:16 range:[-360,360,0]
		spinner floatScaling1DY "Y: " pos:[47,48] width:80 height:16 range:[-360,360,0]
		spinner floatScaling1DZ "Z: " pos:[47,68] width:80 height:16 range:[-360,360,0]
		checkbox boolScalingLink1D "" pos:[145,48] width:16 height:16

		label lblScaling2D "2D" pos:[2,118] width:13 height:15
		spinner floatScaling2DX "X: " pos:[47,98] width:80 height:16 range:[-360,360,0]
		spinner floatScaling2DY "Y: " pos:[47,118] width:80 height:16 range:[-360,360,0]
		spinner floatScaling2DZ "Z: " pos:[47,138] width:80 height:16 range:[-360,360,0]
		checkbox boolScalingLink2D "" pos:[145,118] width:16 height:16

		label lblScaling3D "3D" pos:[2,189] width:13 height:15
		spinner floatScaling3DX "X: " pos:[47,169] width:80 height:16 range:[-360,360,0]
		spinner floatScaling3DY "Y: " pos:[47,189] width:80 height:16 range:[-360,360,0]
		spinner floatScaling3DZ "Z: " pos:[47,209] width:80 height:16 range:[-360,360,0]
		checkbox boolScalingLink3D "" pos:[145,189] width:16 height:16
	
		ImgTag bmpScaling1D "" pos:[17,34] width:19 height:41 bitmap:(openBitMap (pathDir + "array_icon_bracket.png")) transparent:white
		ImgTag bmpScaling2D "" pos:[17,104] width:19 height:41 bitmap:(openBitMap (pathDir + "array_icon_bracket.png")) transparent:white
		ImgTag bmpScaling3D "" pos:[17,174] width:19 height:41 bitmap:(openBitMap (pathDir + "array_icon_bracket.png")) transparent:white
		ImgTag bmpScalingPadlock1D "" pos:[130,36] width:10 height:41 bitmap:(openBitMap (pathDir + "array_icon_padlock_bracket.png")) transparent:white
		ImgTag bmpScalingPadlock2D "" pos:[130,106] width:10 height:41 bitmap:(openBitMap (pathDir + "array_icon_padlock_bracket.png")) transparent:white
		ImgTag bmpScalingPadlock3D "" pos:[130,176] width:10 height:41 bitmap:(openBitMap (pathDir + "array_icon_padlock_bracket.png")) transparent:white
		dropDownList intScalingType "Scaling Type:" pos:[10,230] width:146 height:40 items:#("Scaling Per Object", "Scaling Total")
		on boolScalingEnabled changed theState do
		(
			if boolScalingEnabled.state then
			(
				floatScaling1DY.enabled = floatScaling1DZ.enabled = not boolScalingLink1D.state
				floatScaling2DY.enabled = floatScaling2DZ.enabled = not boolScalingLink2D.state
				floatScaling3DY.enabled = floatScaling3DZ.enabled = not boolScalingLink3D.state
			) else (
				floatScaling1DY.enabled = floatScaling1DZ.enabled = floatScaling2DY.enabled = false
				floatScaling2DZ.enabled = floatScaling3DY.enabled = floatScaling3DZ.enabled = false
			)
			floatScaling1DX.enabled = floatScaling2DX.enabled = floatScaling3DX.enabled = theState
			boolScalingLink1D.enabled = boolScalingLink2D.enabled = boolScalingLink3D.enabled = theState
			intScalingType.enabled = theState

			updateArrayObj 2 1 1 1 intAAmount1D intAAmount2D intAAmount3D 0 0 0 0 0 0 1
		)
		on boolScalingLink1D changed theState do
		(
			floatScaling1DY.enabled = floatScaling1DZ.enabled = not theState
			floatScaling1DY.value = floatScaling1DZ.value = floatScaling1DX.value
			updateArrayObj 2 1 1 1 intAAmount1D intAAmount2D intAAmount3D 0 0 0 0 0 0 1
		)
		on boolScalingLink2D changed theState do
		(
			floatScaling2DY.enabled = floatScaling2DZ.enabled = not theState
			floatScaling2DY.value = floatScaling2DZ.value = floatScaling2DX.value
			updateArrayObj 2 1 1 1 intAAmount1D intAAmount2D intAAmount3D 0 0 0 0 0 0 1
		)
		on boolScalingLink3D changed theState do
		(
			floatScaling3DY.enabled = floatScaling3DZ.enabled = not theState
			floatScaling3DY.value = floatScaling3DZ.value  = floatScaling3DX.value
			updateArrayObj 2 1 1 1 intAAmount1D intAAmount2D intAAmount3D 0 0 0 0 0 0 1
		)

		on floatScaling1DX changed val do
		(
			if boolScalingLink1D.state do
				floatScaling1DY.value = floatScaling1DZ.value = floatScaling1DX.value
			updateArrayObj 2 1 1 1 intAAmount1D intAAmount2D intAAmount3D 0 0 0 0 0 0 1
		)
		on floatScaling2DX changed val do
		(
			if boolScalingLink2D.state do
				floatScaling2DZ.value = floatScaling2DY.value = floatScaling2DX.value
			updateArrayObj 2 1 1 1 intAAmount1D intAAmount2D intAAmount3D 0 0 0 0 0 0 1
		)
		on floatScaling3DX changed val do
		(
			if boolScalingLink3D.state do
				floatScaling3DZ.value = floatScaling3DY.value = floatScaling3DX.value
			updateArrayObj 2 1 1 1 intAAmount1D intAAmount2D intAAmount3D 0 0 0 0 0 0 1
		)
		on floatScaling1DY changed val do
			updateArrayObj 2 1 1 1 intAAmount1D intAAmount2D intAAmount3D 0 0 0 0 0 0 1
		on floatScaling1DZ changed val do
			updateArrayObj 2 1 1 1 intAAmount1D intAAmount2D intAAmount3D 0 0 0 0 0 0 1
		on floatScaling2DY changed val do
			updateArrayObj 2 1 1 1 intAAmount1D intAAmount2D intAAmount3D 0 0 0 0 0 0 1
		on floatScaling2DZ changed val do
			updateArrayObj 2 1 1 1 intAAmount1D intAAmount2D intAAmount3D 0 0 0 0 0 0 1
		on floatScaling3DY changed val do
			updateArrayObj 2 1 1 1 intAAmount1D intAAmount2D intAAmount3D 0 0 0 0 0 0 1
		on floatScaling3DZ changed val do
			updateArrayObj 2 1 1 1 intAAmount1D intAAmount2D intAAmount3D 0 0 0 0 0 0 1

		on intScalingType selected theState do
			updateArrayObj 2 1 1 1 intAAmount1D intAAmount2D intAAmount3D 0 0 0 0 0 0 1
		
		on rolloutScaling open do
		(
			theState = boolScalingEnabled.state
			if boolScalingEnabled.state then
			(
				floatScaling1DY.enabled = floatScaling1DZ.enabled = not boolScalingLink1D.state
				floatScaling2DY.enabled = floatScaling2DZ.enabled = not boolScalingLink2D.state
				floatScaling3DY.enabled = floatScaling3DZ.enabled = not boolScalingLink3D.state
			) else (
				floatScaling1DY.enabled = floatScaling1DZ.enabled = floatScaling2DY.enabled = false
				floatScaling2DZ.enabled = floatScaling3DY.enabled = floatScaling3DZ.enabled = false
			)
			floatScaling1DX.enabled = floatScaling2DX.enabled = floatScaling3DX.enabled = theState
			boolScalingLink1D.enabled = boolScalingLink2D.enabled = boolScalingLink3D.enabled = theState
			intScalingType.enabled = theState
		)
	)
	--=======================================================================================================
	rollout rolloutOffset "Offset" width:162 height:175
	(
		GroupBox grpOffsetPositon "Offset Position" pos:[4,1] width:154 height:84
		spinner floatOffsetPosX "X Position: " pos:[21,19] width:130 height:16 range:[-999999,999999,0] scale:1
		spinner floatOffsetPosY "Y Position: " pos:[21,40] width:130 height:16 range:[-999999,999999,0] scale:1
		spinner floatOffsetPosZ "Z Position: " pos:[21,61] width:130 height:16 range:[-999999,999999,0] scale:1
		GroupBox grpOffsetRotation "Offset Rotation" pos:[4,86] width:154 height:84
		spinner floatOffsetRotX "X Rotation: " pos:[20,105] width:130 height:16 range:[-999999,999999,0] scale:1
		spinner floatOffsetRotY "Y Rotation" pos:[21,125] width:130 height:16 range:[-999999,999999,0] scale:1
		spinner floatOffsetRotZ "Z Rotation" pos:[21,146] width:130 height:16 range:[-999999,999999,0] scale:1
	
		on floatOffsetPosX changed val do
			updateArrayObj 2 1 1 1 intAAmount1D intAAmount2D intAAmount3D 0 0 0 0 1 0 0
		on floatOffsetPosY changed val do
			updateArrayObj 2 1 1 1 intAAmount1D intAAmount2D intAAmount3D 0 0 0 0 1 0 0
		on floatOffsetPosZ changed val do
			updateArrayObj 2 1 1 1 intAAmount1D intAAmount2D intAAmount3D 0 0 0 0 1 0 0
		
		on floatOffsetRotX changed val do
			updateArrayObj 2 1 1 1 intAAmount1D intAAmount2D intAAmount3D 0 0 0 0 0 1 0
		on floatOffsetRotY changed val do
			updateArrayObj 2 1 1 1 intAAmount1D intAAmount2D intAAmount3D 0 0 0 0 0 1 0
		on floatOffsetRotZ changed val do
			updateArrayObj 2 1 1 1 intAAmount1D intAAmount2D intAAmount3D 0 0 0 0 0 1 0
	)
	--=======================================================================================================
	rollout rolloutLinking "Linking" width:162 height:89
	(
		GroupBox grpLinking "Linking to" pos:[4,1] width:154 height:84
		label strCurrentObjectName "" pos:[68,17] width:87 height:16
		radiobuttons intLinkingTo "" pos:[8,16] width:121 height:32 labels:#("Current:", "Custom/Pick Object:")
		label lblLinkCustom "< none selected >" pos:[28,46] width:127 height:15
		checkbox boolLinkingSplines "Link Splines to Parent" pos:[10,63] width:137 height:14
	
		on intLinkingTo changed theState do -- Change how array objects link
		(
			--if $ != undefined do -- Check if the helper has been created yet
			(
				case theState of
				(
					1:( strLinkParent = $.name )
					2:(
						lblLinkCustom.text = "PICK OBJECT IN SCENE"
						tempSelectObject = pickObject count:1 forceListenerFocus:false
						if tempSelectObject != undefined then
						(
							if tempSelectObject.name == $.name then
							( -- Change from custom to current object as link parent
								strLinkCustom = ""
								lblLinkCustom.text = "< none selected >"
								intLinkingTo.state = 1
								strLinkParent = $.name
							) else ( -- Set link parent to be selected object
								strLinkCustom = lblLinkCustom.text =  tempSelectObject.name
								intLinkingTo.state = 2
								strLinkParent = strLinkCustom as string
							)
						) else (
							if getnodebyname (strLinkParentOld as string) != undefined and strLinkParentOld != $.name then
							( -- if object exist and isn't dummy, set it as link parent
								strLinkCustom = lblLinkCustom.text = strLinkParentOld
								intLinkingTo.state = 2
								strLinkParent = strLinkCustom as string
							) else ( -- Object either doesn't exist or is dummy, set link parent to current dummy
								lblLinkCustom.text = "< none selected >"
								strLinkParent = $.name
								strLinkCustom = ""
								intLinkingTo.state = 1
							)
						)
					)
					default:(
						strLinkParent = $.name
						intLinkingTo.state = 1
					)
				)
				
				-- Get all array objects using wildcard search
				tempExecuteList = #()
				for i in arrSourceDetails do -- Go though all the selected objects
				(
					if intArrayType == 2 then -- 1: Group objects , 2: Random objects
						tempExecuteList = append tempExecuteList (("$'" + (strArrayPrefixName as string) + "Ran" + intUniqueArrayID as string + ".arr_*x*x*'"))
					else
						tempExecuteList = append tempExecuteList (("$'" + (strArrayPrefixName as string) + i[1] + ".arr_*x*x*'"))
				)
				
				linkObjects tempExecuteList strLinkParent -- Link all selected objects with selected parent
				tempExecuteList = undefined -- release variable
				
				updateArrayObj 2 1 1 1 intAAmount1D intAAmount2D intAAmount3D 1 1 1 1 1 1 1

				strLinkParentOld = strLinkParent -- Set current link parent to old link parent
			)
		)
		
		on rolloutLinking open do
		(
			if $ != undefined do -- Check if the helper has been created yet
			(
				strCurrentObjectName.text = $.name -- The object name
				
				if getNodeByName (strLinkCustom) == undefined do
				( -- custom link doesn't exist, reset to default
					lblLinkCustom.text = "< none selected >"
					strLinkParentOld = strLinkParent = $.name as string
					if intLinkingTo.state == 2 do intLinkingTo.state = 1
				)
				
				if intLinkingTo.state == 1 then
				( -- set linking to Current, and use dummy as parent link
					strLinkParentOld = strLinkParent = $.name as string
				) else ( -- set linking to Custom, and use dummy as parent link
					lblLinkCustom.text = strLinkCustom -- Show which object selected on label
					strLinkParentOld = strLinkParent = strLinkCustom
				)
				tempExecuteList = #()
				for i in arrSourceDetails do -- Go though all the selected objects
				(
					if intArrayType == 2 then -- 1: Group objects , 2: Random objects
						tempExecuteList = append tempExecuteList (("$'" + (strArrayPrefixName as string) + "Ran" + intUniqueArrayID as string + ".arr_*x*x*'"))
					else
						tempExecuteList = append tempExecuteList (("$'" + (strArrayPrefixName as string) + i[1] + ".arr_*x*x*'"))
				)
				linkObjects tempExecuteList strLinkParent -- Link all selected objects
				tempExecuteList = undefined -- release variable
				strLinkParentOld = strLinkParent
			)
		)
		on boolLinkingSplines changed theState do
		(
			if $ != undefined do -- Check if the helper has been created yet
			(
				tempExecuteList = #()

				linkObjects tempExecuteList strLinkParent -- Link all selected objects with selected parent
				tempExecuteList = undefined -- release variable
				
				updateArrayObj 2 1 1 1 intAAmount1D intAAmount2D intAAmount3D 1 1 1 1 1 1 1
			)
		)
	)
	--=======================================================================================================
	rollout rolloutRandomObject "Random Objects" width:162 height:44
	(
		GroupBox grpRandomObject "Random Object" pos:[4,1] width:154 height:39
		spinner intRanObjectSeed "Seed: " type:#integer pos:[18,18] width:112 height:16 range:[1,999999,1] scale:1
		button btnROGenerateSeed "G" pos:[134,17] width:18 height:18
		
		on intRanObjectSeed changed val do -- If random id changed, update array
			updateArrayObj 1 1 1 1 intAAmount1D intAAmount2D intAAmount3D 1 1 1 1 1 1 1

		on btnROGenerateSeed pressed do -- Generate new random seed and update array
		(
			seed(timeStamp())
			intRanObjectSeed.value = random 1 999999
			deleteArrayObj 1 1 1 1 1 1 1 -- first delete all objects
			addArrayObj 3 1 1 1 intAAmount1D intAAmount2D intAAmount3D
			updateArrayObj 1 1 1 1 intAAmount1D intAAmount2D intAAmount3D 1 1 1 1 1 1 1
		)
		on rolloutRandomObject open do
		(
			if intArrayType == 1 then
			(
				intRanObjectSeed.enabled = false
				btnROGenerateSeed.enabled = false
			) else (
				intRanObjectSeed.enabled = true
				btnROGenerateSeed.enabled = true
			)
		)
	)
	--=======================================================================================================
	rollout rolloutConvert "Convert" width:162 height:176
	(
		GroupBox grpRename "Rename" pos:[4,1] width:154 height:63
		dropdownList strConvertNewName "" pos:[9,17] width:146 height:21 items:#("prefix + objectname + XxYxZ", "prefix + objectname + #", "custom + #", "custom + objectname + #", "objectname + custom + #") selection:3
		edittext strConvertCustom "Custom: " pos:[8,41] width:146 height:17
		GroupBox grpConvertTo "Convert To" pos:[4,65] width:154 height:43
		dropdownList strConvertTo "" pos:[9,82] width:146 height:21 items:#("Instance with Respect", "Copy", "Rename Only") selection:2
		button btnStartConvert "Start Convert" pos:[43,153] width:76 height:18	
		GroupBox grpConvertGroup "Group Name" pos:[4,109] width:154 height:40
		edittext strGroupName "" pos:[6,125] width:144 height:17
	
		on btnStartConvert pressed do -- Start convert and rename all array objects
		(
			with redraw off (
				tempRename = strConvertNewName.selected as string
				if (matchPattern tempRename pattern:"*custom*") == true and strConvertCustom.text == "" then
				(
					messagebox "You need to enter a custom name with the selected Rename filter."
				) else (
					strObjectCollection = #()
					for i in arrSourceDetails do
						join strObjectCollection (getNodeByName (strArrayPrefixName + i[1] as string + ".arr_*x*x*"))

					if strConvertTo.selected == "Instance with Respect" do
						instancemgr.makeobjectsunique strObjectCollection #group
					if strConvertTo.selected == "Copy" do
						instancemgr.MakeObjectsUnique strObjectCollection #individual
					strObjectCollection = undefined --release variable
				)
				-- Rename objects
				tempPObjectList = strSourceObjectList as array
				tempPObjectListCount = arrSourceDetails.count
				groupList = #()
				rolloutObjectCreation.intObjCreation.state = 4
				totalAmount = intAAmount1D * intAAmount2D * intAAmount3D
				for i in arrSourceDetails do
				(
					strSourceName = i[1]
					strSourceObj = i[2]
					newCount = 1
					for z = 1 to intAAmount3D do
						for y = 1 to intAAmount2D do
							for x = 1  to intAAmount1D do
							(
								strChildName = strPreviousPrefixName + strSourceName as string + ".arr_" + (x as string) + "x" + (y as string) + "x" + (z as string)
								if intArrayType == 2  then
								(
									strChildName = (strArrayPrefixName as string) + "Ran" + intUniqueArrayID as string + ".arr_" + (x as string) + "x" + (y as string) + "x" + (z as string)
									strSourceName = strChildName
									strSourceObj = getnodebyname (strChildName)
								)
								strChildObj = getNodeByName (strChildName)
								if strChildObj != undefined do
								(
									case tempRename of
									(
										"prefix + objectname + XxYxZ": New_Name = strArrayPrefixName as string + strSourceName + (x as string) + "x" + (y as string) + "x" + (z as string)
										"prefix + objectname + #": New_Name = uniquename (strArrayPrefixName as string + strSourceName)
										"custom + #": New_Name = uniquename (strConvertCustom.text as string)
										"custom + objectname + #": New_Name = uniquename (strConvertCustom.text as string + strSourceName)
										"objectname + custom + #": New_Name =uniquename (strSourceName + strConvertCustom.text as string)
										default: New_Name = strArrayPrefixName as string + strSourceName + (x as string) + "x" + (y as string) + "x" + (z as string)
									)
									strChildObj = getNodeByName (strChildName as string)
									strChildObj.name = New_Name
									strChildObj.parent = undefined

									newCount += newCount
									groupList = append groupList strChildName
								)
							)
				)
				group groupList name:strGroupName.text
				seed(timeStamp())
				strGroupName.text = uniquename("GroupArray" + ((random 100000 999999) as string))
				groupList = undefined -- release variable
			)
		)
		
		on strConvertNewName selected theState do
		(
			tempRename = strConvertNewName.selected as string
			if (matchPattern tempRename pattern:"*custom*") then
				strConvertCustom.enabled = true
			else
				strConvertCustom.enabled = false
		)

		on strGroupName entered newName do -- Check if group name is changed or is empty
		(
 			if strGroupName.text == "" then -- If empty, retrieve the old name
 			(
 				messageBox "The group name cannot be empty."
 				strGroupName.text = strPreGroupName
 			) else (
 				strPreGroupName = newName
 			)
		)

		on rolloutConvert open do
		(
			tempRename = strConvertNewName.selected as string
			strConvertCustom.enabled = (matchPattern tempRename pattern:"*custom*")
			if strGroupName.text == "" do
			(
				seed(timeStamp())
				strGroupName.text = uniquename("GroupArray" + ((random 100000 999999) as string))
			)
			strPreGroupName = strGroupName.text
		)
	)
	--=======================================================================================================
	rollout AboutArray "About..." width:162 height:80
	(
		label TitleLabel "Array 3D v0.83" pos:[46,7] width:71 height:13
		label CreatedByLabel "Created by" pos:[56,25] width:51 height:13
		label CreatedByName "Anders K. 'McGreed' Nielsen" pos:[14,43] width:135 height:13
		label UrlLabel "http://www.mcgreed.dk/" pos:[20,61] width:119 height:15
	)
)